#include "p_gfxinit.h"

#include "RoNDi.h"

#include "screens.h"
#include "tape.h"

Boolean ApplicationHandleMenu(UInt16 menuID)
{
	Boolean handled = false;

	switch (menuID)
	{
		// Event handler for menu item
		case mnufrmMain:
			handled = true;
			break;
		case mnuQSave:
			handled = true;
			TapeQuickSave();
			ResetTicks();
			break;
		case mnuQLoad:
			handled = true;
			TapeQuickLoad();
			ResetTicks();
			break;
		case mnuRestartLev:
			handled = true;
			if(AllPlayersGone||FrmAlert(alt_RestartLevel)==0)
				DrawMainMenu();
			else
				ResetTicks();
			break;
		case mnuNextLev:
			handled = true;
			if(FrmAlert(alt_PlayNextLev)==0)
			{
				int ls=LevelSets->cur_levset;
				if(ls>=0)
				{
					if(level_nr<=LevelSets->last_won_level[ls]||DS_Cheating)
						level_nr++;
					else
						level_nr=0;
					LevelSets->cur_level[ls]=level_nr;
				}

				DrawMainMenu();
			}
			ResetTicks();
			break;
		case mnuNextLevSet:
			handled = true;
			{
				int answer;
				int next_levset=LevelSets->cur_levset+1;
				if (next_levset>LevelSets->num_levsets)
					next_levset=0;
				
				while((answer=FrmCustomAlert(alt_PlayNextLevSet,
						LevelSets->name[next_levset],NULL,NULL))==1)
				{
					next_levset++;
					if (next_levset>LevelSets->num_levsets)
						next_levset=0;
				}

				if(answer==0)
				{
					LevelSets->cur_levset=next_levset;
					level_nr=LevelSets->cur_level[next_levset];
					DrawMainMenu();
				}
				else
					ResetTicks();
			}
			break;
		case mnuDebugInfo:
			handled = true;
			{
				char TmpStr[10];
/*				short int y,xx;

				for (y = 0,xx=0; y < lev_fieldy; y++)
					xx+=StopY[y];
				bugd("StopY sum",xx);				

				for (y = 0,xx=0; y < lev_fieldy; y++)
					xx+=ExplodeFieldY[y];
				bugd("ExplodeFieldY sum",xx);				

				for (y = 0,xx=0; y < lev_fieldy; y++)
					xx+=FeldYExplosion[y];
				bugd("FeldYExplosion sum",xx);				
*/
				StrIToA(TmpStr,time50);
				FrmCustomAlert(alt_String1,
							"Last valid 50 frames rendered in .01 sec: ",TmpStr,NULL);

				StrIToA(TmpStr,last50tiles);
				FrmCustomAlert(alt_String1,
							"Last valid 50 frames #of Tiles rendered: ",TmpStr,NULL);

				StrIToA(TmpStr,waiter);
				FrmCustomAlert(alt_String1,
							"In last 50 frames SysTaskDelay called: ",TmpStr,NULL);

				StrIToA(TmpStr,last50StartMoving);
				FrmCustomAlert(alt_String1,
							"In last valid 50 frames count of MDL_OTHER: ",
							TmpStr,NULL);

				StrIToA(TmpStr,last50BigStartMoving);
				FrmCustomAlert(alt_String1,
							"In last valid 50 frames count of call StartMoving: ",
							TmpStr,NULL);
			}
			ResetTicks();
			break;
		case mnuDSettings:
			handled = true;
			{
				int answer=FrmAlert(alt_DSettings);
				ResetTicks();
				switch(answer)
				{
					case 0: DS_Cheating^=1;break;
					case 1: DS_MDL_Other^=1;break;
					case 2: DS_TestRender=1;break;
				}
			}
			break;
		default:
			break;
	}

	return handled;
}
