#ifndef GAME_H_INCLUDED
#define GAME_H_INCLUDED

#include "main_.h" 
#include "code_sections.h"

void DrawGameDoorValues(void) INIT_SECTION;
void InitGame(void) INIT_SECTION;
void InitMovDir(int, int);

void InitAmoebaNr(int, int);
void GameWon(void);

void InitPlayerGfxAnimation(struct PlayerInfo *, int, int) LOGIC_SECTION;
void InitMovingField(short int, char) LOGIC_SECTION;

void Moving2Blocked(short int, short int *) LOGIC_SECTION;
void Blocked2Moving(short int, short int *) LOGIC_SECTION;
int MovingOrBlocked2Element(int, int) LOGIC_SECTION;

void DrawDynamite(int, int)LOGIC_SECTION;

void Explode(int, int, int, int) GFX_SECTION;
void DynaExplode(int, int) GFX_SECTION;
void Bang(int, int) GFX_SECTION;

void Impact(int, int) GFX_SECTION;
void StartMoving(int, int) LOGIC_SECTION;
void ContinueMoving(int, int) LOGIC_SECTION;
int AmoebeNachbarNr(int, int) LOGIC_SECTION;
void AmoebeUmwandeln(int, int) LOGIC_SECTION;
void AmoebeUmwandelnBD(int, int, int) LOGIC_SECTION;
void AmoebeWaechst(int, int) LOGIC_SECTION;
void AmoebeAbleger(int, int) LOGIC_SECTION;
void Life(int, int) LOGIC_SECTION;

void MauerWaechst(int, int) LOGIC_SECTION;
void MauerAbleger(int, int);

void GameActions(void) LOGIC_SECTION;
void ScrollLevel(int, int) LOGIC_SECTION;

void KillHero(struct PlayerInfo *);
void BuryHero(struct PlayerInfo *);
void RemoveHero(struct PlayerInfo *);

boolean SnapField(struct PlayerInfo *, int, int);
boolean DropElement(struct PlayerInfo *);

void RaiseScore(int) INIT_SECTION;
void RaiseScoreElement(int) INIT_SECTION;

#endif
