#include <PalmOS.h>

#include "libgamemisc.h"
#include "libgamerandom.h"

//!!!!!!!!!!!!!start!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
UInt16 sysTicks_ms; 
//!!!!!!!!!!!!!!!end!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

static unsigned long mainCounter(int mode)
{
	static unsigned long base_ms = 0;
	unsigned long current_ms;
	unsigned long counter_ms;
//!!!!!!!!!!!!!start!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	current_ms = TimGetTicks();//10 ms is standart value!!!!!!!!
//!!!!!!!!!!!!!!!end!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	/* reset base time in case of counter initializing or wrap-around */
	if (mode == INIT_COUNTER || current_ms < base_ms)
		base_ms = current_ms;

	counter_ms = current_ms - base_ms;

	return counter_ms;		/* return milliseconds since last init */
}
 
void InitCounter()		/* set counter back to zero */
{
//!!!!!!!!!!!!!start!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	sysTicks_ms=SysTicksPerSecond();
//!!!!!!!!!!!!!!!end!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	mainCounter(INIT_COUNTER);
}

void DelayX10(unsigned long delay)
{
	SysTaskDelay(delay);
}

boolean FrameReached(unsigned long *frame_counter_var,
					 unsigned long frame_delay)
{
	unsigned long actual_frame_counter = FrameCounter;

	if (actual_frame_counter >= *frame_counter_var &&
			actual_frame_counter < *frame_counter_var + frame_delay)
		return FALSE;

	*frame_counter_var = actual_frame_counter;

	return TRUE;
}

/* ------------------------------------------------------------------------- */
/* random generator functions                                                */
/* ------------------------------------------------------------------------- */

unsigned long init_random_number(int nr, long seed)//was int
{
	if (seed == NEW_RANDOMIZE)
	{
		seed = TimGetTicks();
	}

	srandom_linux_libc(nr, (unsigned long) seed);//was int

	return (unsigned long) seed;//was int
}

unsigned long get_random_number(int nr, long max)//was int
{
	if (max>1)
	{
		long val=random_linux_libc(nr);
		if(max==2)return val&1;
		if(max==4)return val&3;
		if(max==8)return val&7;
		return val % max;
	}
	return 0;
}