#include <PalmOS.h>
#include "libgamesetup.h"

long getFileVersionFromCookieString(const char *cookie)//was int
{
	const char *ptr_cookie1, *ptr_cookie2;
	const char *pattern1 = "_FILE_VERSION_";
	const char *pattern2 = "?.?";
	const int len_cookie = StrLen(cookie);
	const int len_pattern1 = StrLen(pattern1);
	const int len_pattern2 = StrLen(pattern2);
	const int len_pattern = len_pattern1 + len_pattern2;
	unsigned long version_major, version_minor;

	if (len_cookie <= len_pattern)
		return -1;

	ptr_cookie1 = &cookie[len_cookie - len_pattern];
	ptr_cookie2 = &cookie[len_cookie - len_pattern2];

	if (StrNCompare(ptr_cookie1, pattern1, len_pattern1) != 0)
		return -1;

	if (ptr_cookie2[0] < '0' || ptr_cookie2[0] > '9' ||
 						ptr_cookie2[1] != '.' ||
						ptr_cookie2[2] < '0' || ptr_cookie2[2] > '9')
		return -1;

	version_major = ptr_cookie2[0] - '0';
	version_minor = ptr_cookie2[2] - '0';

	return VERSION_IDENT(version_major, version_minor, 0, 0);
}

boolean checkCookieString(const char *cookie, const char *template_)
{
	const char *pattern = "_FILE_VERSION_?.?";
	const int len_cookie = StrLen(cookie);
	const int len_template = StrLen(template_);
	const int len_pattern = StrLen(pattern);

	if (len_cookie != len_template)
		return FALSE;

	if (StrNCompare(cookie, template_, len_cookie - len_pattern) != 0)
		return FALSE;

	return TRUE;
} 