#include "p_gfxinit.h"

Int32	ticks_wait;
Int32	ideal_ticks;
Int32	IdealTick;
Int32	cur_tick;
Int32	old_tick;

MemHandle      TileResH[BitMap_TotalNo];
unsigned long *TileResP0[BitMap_TotalNo];
unsigned long *TileResP[BitMap_TotalNo];

struct LevSetInfo *LevelSets=NULL;

void ResetTicks(void)
{
	ideal_ticks=0;
	frames50=0;
	cur_tick = TimGetTicks();
	old_tick=cur_tick;
}

Int32	NameStartTick;

void ShowLevelName(void)
{
	RectangleType Rc;

	Rc.topLeft.x=0;
	Rc.topLeft.y=0;
	Rc.extent.x=160;
	Rc.extent.y=14;

	WinEraseRectangle (&Rc,0);
	WinDrawChars(level.name,StrLen(level.name),0,0);
	NameStartTick = TimGetTicks();
}

void EndShowingLevelName(void)
{
	RectangleType Rc;
	Int32 cur_tick = TimGetTicks();

	Rc.topLeft.x=0;
	Rc.topLeft.y=0;
	Rc.extent.x=160;
	Rc.extent.y=8;
	
	if(cur_tick-NameStartTick<150)
		SysTaskDelay(150-cur_tick+NameStartTick);
	WinEraseRectangle (&Rc,0);
	 
}

void LoadLevelSetsInfo(void)
{
	int i;
	Int16 x;
	UInt16 pref_size;
	pref_size=sizeof(struct LevSetInfo);
	x=PrefGetAppPreferences( CREATOR, 0, LevelSets, &pref_size, true);
	if(pref_size!=sizeof(struct LevSetInfo))
		x=noPreferenceFound;
	if(x==noPreferenceFound ||x!=1)
	{
		LevelSets->num_levsets=-1;
		LevelSets->cur_levset=-1;
		return;
	} 
//reset dbid and card for saved
	if(LevelSets->num_levsets>MAXLEVSETS-1)
	{
		bugd("Saved num_levelsets invalid:",LevelSets->num_levsets);
		LevelSets->num_levsets=-1;
		LevelSets->cur_levset=-1;
		return;
	}

	if(LevelSets->cur_levset>LevelSets->num_levsets)
	{
		bugd("Saved cur_levelset invalid:",LevelSets->cur_levset);
		LevelSets->cur_levset=0;
	}

	for(i=0;i<=LevelSets->num_levsets;i++)
	{
		LevelSets->dbid[i]=0;
		LevelSets->card[i]=0;
	}

};

INIT_SECTION static void InsertLevelDB(UInt16 cur_card, LocalID cur_dbid, 
											char* cur_name, char levset_type)
{
	int i;
	for(i=0;i<=LevelSets->num_levsets;i++)
	{
		if(StrCompare(cur_name,LevelSets->name[i])==0)
		{
//			bugd(cur_name,(long)cur_dbid+cur_card*256*256);
			LevelSets->dbid[i]=cur_dbid;
			LevelSets->card[i]=cur_card;
			return;
		}
	}
	
	if(LevelSets->num_levsets>=MAXLEVSETS-1)
	{
		bugd("UUPS!! overflow of LevelSets",0);
		return;
	}

	LevelSets->num_levsets++;
	i=LevelSets->num_levsets;

	LevelSets->dbid[i]=cur_dbid;
	LevelSets->card[i]=cur_card;
	LevelSets->last_won_level[i]=-1;
	LevelSets->cur_level[i]=0;
	LevelSets->levset_type[i]=levset_type;

	StrCopy(LevelSets->name[i],cur_name);
};

INIT_SECTION void RemoveDeletedLevelDB(void)
{
	int i,sz;
	for(i=0;i<=LevelSets->num_levsets;i++)
		if(LevelSets->dbid[i]==0&&LevelSets->card[i]==0)
		{
			if(LevelSets->cur_levset==i)
				LevelSets->cur_levset=0;
			sz=LevelSets->num_levsets;
			if(i<sz)
			{
				if(LevelSets->cur_levset==sz)
					LevelSets->cur_levset=i;
				StrCopy(LevelSets->name[i],LevelSets->name[sz]);
				LevelSets->dbid[i]=LevelSets->dbid[sz];
				LevelSets->card[i]=LevelSets->card[sz];
				LevelSets->cur_level[i]=LevelSets->cur_level[sz];
				LevelSets->last_won_level[i]=LevelSets->last_won_level[sz];
				LevelSets->levset_type[i]=LevelSets->levset_type[sz];
			}
			LevelSets->num_levsets--;
		}
	if(LevelSets->cur_levset==-1&&LevelSets->num_levsets>=0)
		LevelSets->cur_levset=0;
		
	level_nr=0;
	i=LevelSets->cur_levset;
	if(LevelSets->cur_levset>=0 && 
				LevelSets->cur_level[i]>0)
		level_nr=LevelSets->cur_level[i];
}

void SaveLevelSetsInfo(void)
{
	PrefSetAppPreferences( CREATOR, 0, 1, LevelSets, sizeof(struct LevSetInfo), true);
	//0 id of prefs is level set info
}

void FindAllLevelDBs(void)
{
	LocalID	cur_dbid;
	UInt16	cur_card;
	char cur_name[32];
	DmSearchStateType stateInfo;

	Err err;
	Boolean first;

	first = true;

	while((err = DmGetNextDatabaseByTypeCreator(first, 
				&stateInfo, RND_TYPE, CREATOR, false, 
				&cur_card, &cur_dbid))==errNone)
	{
		DmDatabaseInfo(cur_card, cur_dbid, cur_name, 
						0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
		if(LevelSets->num_levsets<MAXLEVSETS)
			InsertLevelDB(cur_card, cur_dbid, cur_name, LEVEL_FILE_TYPE_RND);
		else
			bugd("Too many level sets! Ignoring not first 10",0);
		first = false;
	} 

	first = true;

	while((err = DmGetNextDatabaseByTypeCreator(first, 
				&stateInfo, EM_TYPE, CREATOR, false, 
				&cur_card, &cur_dbid))==errNone)
	{
		DmDatabaseInfo(cur_card, cur_dbid, cur_name, 
						0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
		if(LevelSets->num_levsets<MAXLEVSETS)
			InsertLevelDB(cur_card, cur_dbid, cur_name, LEVEL_FILE_TYPE_EM); 
		else
			bugd("Too many level sets! Ignoring not first 10",0);
		first = false;
	} 

	RemoveDeletedLevelDB();
/*	{
	int i;
	for(i=0;i<LevelSets->num_levsets;i++)
		bugd(LevelSets->name[i],(long)LevelSets->dbid[i]+LevelSets->card[i]*256*256);
	}*/
};

#define	PrepareMem(ptr,size)	{ptr=MemPtrNew(size);if(ptr==NULL) return 2;}

int PrepareResources(void)
{
	int i;

	PrepareMem(graphic_infoF,sizeof(struct GraphicInfo));
	PrepareMem(anim_infoF,sizeof(struct AnimationInfo));
	PrepareMem(element_infoF,sizeof(struct ElementInfo));
	PrepareMem(element_graphic_infoF,sizeof(struct ElementGraphicInfo));
	PrepareMem(MovDelay,MAX_LEV_FIELDX*MAX_LEV_FIELDY*2);
	PrepareMem(Store,MAX_LEV_FIELDX*MAX_LEV_FIELDY*2);
	PrepareMem(Store2,MAX_LEV_FIELDX*MAX_LEV_FIELDY*2);
	PrepareMem(Back,MAX_LEV_FIELDX*MAX_LEV_FIELDY*2);
	PrepareMem(AmoebaNr,MAX_LEV_FIELDX*MAX_LEV_FIELDY);
	PrepareMem(ExplodeFlags,MAX_LEV_FIELDX*MAX_LEV_FIELDY);
//	PrepareMem(Gfx,MAX_LEV_FIELDX*MAX_LEV_FIELDY*2);
	PrepareMem(GfxElement,MAX_LEV_FIELDX*MAX_LEV_FIELDY*2);
	PrepareMem(GfxSFrame,MAX_LEV_FIELDX*MAX_LEV_FIELDY*2);
	PrepareMem(GfxRandom,MAX_LEV_FIELDX*MAX_LEV_FIELDY);
	PrepareMem(LevelSets,sizeof(struct LevSetInfo));
	
	for(i=0;i<BitMap_TotalNo;i++)
	{
		TileResH[i] = DmGetResource('Tbmp', BitMap_id+i);
		if(TileResH[i]==NULL)
			return 1;//bad-res not found
		TileResP0[i] = MemHandleLock(TileResH[i]);
		TileResP[i]=TileResP0[i]+4;
	}

	return 0;
}

#define	ReleaseMem(ptr)	if(ptr!=NULL)MemPtrFree(ptr) 

void ReleaseResources(void)
{
	int i;

	ReleaseMem(graphic_infoF);
	ReleaseMem(anim_infoF);
	ReleaseMem(element_infoF);
	ReleaseMem(element_graphic_infoF);
	ReleaseMem(MovDelay);
	ReleaseMem(Store);
	ReleaseMem(Store2);
	ReleaseMem(Back);
	ReleaseMem(AmoebaNr);
	ReleaseMem(ExplodeFlags);
//	ReleaseMem(Gfx);
	ReleaseMem(GfxElement);
	ReleaseMem(GfxSFrame);
	ReleaseMem(GfxRandom);
	ReleaseMem(LevelSets);
	
	for(i=0;i<BitMap_TotalNo;i++)
	{
		if(TileResH[i]!=NULL)
		{
			MemPtrUnlock(TileResP0[i]);
			DmReleaseResource(TileResH[i]);
		}
	}
}

int UseLatestEngine(void)
{
//latest_engine true for bd_* and classic_*
	char * cur_lsn = LevelSets->name[(int)LevelSets->cur_levset];
	if (StrNCompare(cur_lsn,"classic_",8)==0 
				|| StrNCompare(cur_lsn,"bd_",3)==0)
		return 1;
	return 0;
}

int GetEM_LevelOffset(void)
{
	char * cur_lsn = LevelSets->name[(int)LevelSets->cur_levset];
	int s_sz = StrLen(cur_lsn);
	if(s_sz<4)
		return 0;
	cur_lsn+=s_sz-4;
	if(cur_lsn[0]!='_'||cur_lsn[1]!='f'||cur_lsn[2]<'0'||cur_lsn[2]>'9'||
					cur_lsn[3]<'0'||cur_lsn[3]>'9')
		return 0;
	return (int)(cur_lsn[3]-'0'+10*(cur_lsn[2]-'0'));
}

void SetDefaultGraphic(void)
{
	int i,j;
	const struct 
		{short int no; byte bmp_id;byte x_y;}
	DefGrInfo[]=
	{
		{IMG_BD_WALL,RocksDC_id,12+9*16},
		{IMG_BD_ROCK,RocksDC_id,12+10*16},
		{IMG_BD_DIAMOND,RocksElements_id,10*16},
		{IMG_BD_DIAMOND_MOVING,RocksElements_id,3+10*16},
		{IMG_BD_MAGIC_WALL,RocksElements_id,12+10*16},
		{IMG_BD_AMOEBA,RocksElements_id,8+6*16},
		{IMG_BD_BUTTERFLY,RocksElements_id,4+12*16},
		{IMG_BD_FIREFLY,RocksElements_id,6+12*16},
		{IMG_SP_DEFAULT_EXPLODING,RocksSP_id,8+3*16},
		{IMG_SP_ZONK,RocksSP_id,1},
		{IMG_SP_ZONK_MOVING_LEFT,RocksSP_id,6*16},
		{IMG_SP_BASE,RocksSP_id,2},
		{IMG_SP_MURPHY,RocksSP_id,3},
		{IMG_SP_MURPHY_MOVING_LEFT,RocksSP_id,8},
		{IMG_SP_MURPHY_MOVING_RIGHT,RocksSP_id,11},
		{IMG_SP_MURPHY_PUSHING_LEFT,RocksSP_id,11+16*1},
		{IMG_SP_MURPHY_PUSHING_RIGHT,RocksSP_id,10+16*1},
		{IMG_SP_MURPHY_SNAPPING_LEFT,RocksSP_id,9+16*1},
		{IMG_SP_MURPHY_SNAPPING_RIGHT,RocksSP_id,8+16*1},
		{IMG_SP_MURPHY_SNAPPING_UP,RocksSP_id,14},
		{IMG_SP_MURPHY_SNAPPING_DOWN,RocksSP_id,15},
		{IMG_SP_MURPHY_CLONE,RocksSP_id,3},
		{IMG_SP_INFOTRON,RocksSP_id,4},
		{IMG_SP_CHIP_SINGLE,RocksSP_id,5},
		{IMG_SP_CHIP_LEFT,RocksSP_id,2+3*16},
		{IMG_SP_CHIP_RIGHT,RocksSP_id,3+3*16},
		{IMG_SP_CHIP_TOP,RocksSP_id,6+4*16},
		{IMG_SP_CHIP_BOTTOM,RocksSP_id,7+4*16},
		{IMG_SP_HARDWARE_GRAY,RocksSP_id,6},
		{IMG_SP_HARDWARE_GREEN,RocksSP_id,5+3*16},
		{IMG_SP_HARDWARE_BLUE,RocksSP_id,6+3*16},
		{IMG_SP_HARDWARE_RED,RocksSP_id,7+3*16},
		{IMG_SP_HARDWARE_YELLOW,RocksSP_id,4+16},
		{IMG_SP_EXIT_CLOSED,RocksSP_id,7},
		{IMG_SP_DISK_ORANGE,RocksSP_id,16},
		{IMG_SP_DISK_YELLOW,RocksSP_id,2+2*16},
		{IMG_SP_DISK_RED,RocksSP_id,4+2*16},
		{IMG_SP_DISK_RED_ACTIVE,RocksSP_id,4+2*16},
		{IMG_SP_PORT_RIGHT,RocksSP_id,1+1*16},
		{IMG_SP_PORT_DOWN,RocksSP_id,2+1*16},
		{IMG_SP_PORT_LEFT,RocksSP_id,3+1*16},
		{IMG_SP_PORT_UP,RocksSP_id,4+1*16},
		{IMG_SP_PORT_HORIZONTAL,RocksSP_id,6+2*16},
		{IMG_SP_PORT_VERTICAL,RocksSP_id,5+2*16},
		{IMG_SP_PORT_ANY,RocksSP_id,7+2*16},
		{IMG_SP_GRAVITY_PORT_RIGHT,RocksSP_id,1+1*16},
		{IMG_SP_GRAVITY_PORT_DOWN,RocksSP_id,2+1*16},
		{IMG_SP_GRAVITY_PORT_LEFT,RocksSP_id,3+1*16},
		{IMG_SP_GRAVITY_PORT_UP,RocksSP_id,4+1*16},
		{IMG_SP_GRAVITY_ON_PORT_RIGHT,RocksSP_id,1+1*16},
		{IMG_SP_GRAVITY_ON_PORT_DOWN,RocksSP_id,2+1*16},
		{IMG_SP_GRAVITY_ON_PORT_LEFT,RocksSP_id,3+1*16},
		{IMG_SP_GRAVITY_ON_PORT_UP,RocksSP_id,4+1*16},
		{IMG_SP_GRAVITY_OFF_PORT_RIGHT,RocksSP_id,1+1*16},
		{IMG_SP_GRAVITY_OFF_PORT_DOWN,RocksSP_id,2+1*16},
		{IMG_SP_GRAVITY_OFF_PORT_LEFT,RocksSP_id,3+1*16},
		{IMG_SP_GRAVITY_OFF_PORT_UP,RocksSP_id,4+1*16},
		{IMG_SP_SNIKSNAK,RocksSP_id,1+2*16},
		{IMG_SP_SNIKSNAK_LEFT,RocksSP_id,8+8*16},
		{IMG_SP_SNIKSNAK_RIGHT,RocksSP_id,12+8*16},
		{IMG_SP_SNIKSNAK_UP,RocksSP_id,8+9*16},
		{IMG_SP_SNIKSNAK_DOWN,RocksSP_id,12+9*16},
		{IMG_SP_SNIKSNAK_TURNING_FROM_LEFT_UP,RocksSP_id,12+1*16},
		{IMG_SP_SNIKSNAK_TURNING_FROM_LEFT_DOWN,RocksSP_id,14+1*16},
		{IMG_SP_SNIKSNAK_TURNING_FROM_RIGHT_UP,RocksSP_id,8+11*16},
		{IMG_SP_SNIKSNAK_TURNING_FROM_RIGHT_DOWN,RocksSP_id,10+11*16},
		{IMG_SP_SNIKSNAK_TURNING_FROM_UP_LEFT,RocksSP_id,12+11*16},
		{IMG_SP_SNIKSNAK_TURNING_FROM_UP_RIGHT,RocksSP_id,14+11*16},
		{IMG_SP_SNIKSNAK_TURNING_FROM_DOWN_LEFT,RocksSP_id,12+6*16},
		{IMG_SP_SNIKSNAK_TURNING_FROM_DOWN_RIGHT,RocksSP_id,14+6*16},
		{IMG_SP_ELECTRON,RocksSP_id,8+10*16},
		{IMG_SP_ELECTRON_EXPLODING,RocksSP_id,8+4*16},
		{IMG_SP_TERMINAL,RocksSP_id,10*16},
		{IMG_SP_TERMINAL_ACTIVE,RocksSP_id,11*16},
		{IMG_SP_BUGGY_BASE,RocksSP_id,1+3*16},
		{IMG_SP_BUGGY_BASE_ACTIVATING,RocksSP_id,15+2*16},
		{IMG_SP_BUGGY_BASE_ACTIVE,RocksSP_id,8+6*16},
		{IMG_SP_HARDWARE_BASE_1,RocksSP_id,4+3*16},
		{IMG_SP_HARDWARE_BASE_2,RocksSP_id,1+4*16},
		{IMG_SP_HARDWARE_BASE_3,RocksSP_id,2+4*16},
		{IMG_SP_HARDWARE_BASE_4,RocksSP_id,3+4*16},
		{IMG_SP_HARDWARE_BASE_5,RocksSP_id,4+4*16},
		{IMG_SP_HARDWARE_BASE_6,RocksSP_id,5+4*16},
		{IMG_SOKOBAN_OBJECT,RocksElements_id,9+7*16},
		{IMG_SOKOBAN_FIELD_EMPTY,RocksElements_id,10+7*16},
		{IMG_SOKOBAN_FIELD_FULL,RocksElements_id,11+7*16},
		{IMG_SOKOBAN_FIELD_PLAYER,RocksHeroes_id,0+15*16},
		{IMG_EMPTY_SPACE,RocksSP_id,0},
		{IMG_SAND,RocksElements_id,0},
		{IMG_SAND_CRUMBLED,RocksElements_id,1},
		{IMG_SAND_DIGGING_LEFT,RocksMore_id,6+3*16},
		{IMG_SAND_DIGGING_RIGHT,RocksMore_id,9+3*16},
		{IMG_SAND_DIGGING_UP,RocksMore_id,3*16},
		{IMG_SAND_DIGGING_DOWN,RocksMore_id,3+3*16},
		{IMG_WALL,RocksElements_id,5},
		{IMG_WALL_SLIPPERY,RocksElements_id,6},
		{IMG_STEELWALL,RocksElements_id,4},
		
		{IMG_ROCK,RocksElements_id,12},
		{IMG_EMERALD,RocksElements_id,8},
		{IMG_EMERALD_COLLECTING,RocksMore_id,3+2*16},
		{IMG_DIAMOND,RocksElements_id,10},
		{IMG_DIAMOND_COLLECTING,RocksMore_id,7+2*16},
		{IMG_BOMB,RocksElements_id,1*16+11},
		{IMG_NUT,RocksElements_id,1*16+12},
		{IMG_NUT_BREAKING,RocksElements_id,1*16+13},
		{IMG_DYNAMITE,RocksElements_id,3*16},
		{IMG_DYNAMITE_ACTIVE,RocksElements_id,3*16+1},
		{IMG_WALL_EMERALD,RocksElements_id,4+8*16},
		{IMG_WALL_DIAMOND,RocksElements_id,5+8*16},
		{IMG_BUG,RocksElements_id,12+3*16},
		{IMG_BUG_RIGHT,RocksElements_id,12+3*16},
		{IMG_BUG_UP,RocksElements_id,13+3*16},
		{IMG_BUG_LEFT,RocksElements_id,14+3*16},
		{IMG_BUG_DOWN,RocksElements_id,15+3*16},
		{IMG_BUG_MOVING_RIGHT,RocksElements_id,8+4*16},
		{IMG_BUG_MOVING_UP,RocksElements_id,10+4*16},
		{IMG_BUG_MOVING_LEFT,RocksElements_id,12+4*16},
		{IMG_BUG_MOVING_DOWN,RocksElements_id,14+4*16},
		{IMG_BUG_TURNING_FROM_RIGHT_UP,RocksMore_id,1+6*16},
		{IMG_BUG_TURNING_FROM_UP_LEFT,RocksMore_id,13+6*16},
		{IMG_BUG_TURNING_FROM_LEFT_DOWN,RocksMore_id,9+6*16},
		{IMG_BUG_TURNING_FROM_DOWN_RIGHT,RocksMore_id,5+6*16},
		{IMG_BUG_TURNING_FROM_RIGHT_DOWN,RocksMore_id,6+6*16},
		{IMG_BUG_TURNING_FROM_UP_RIGHT,RocksMore_id,2+6*16},
		{IMG_BUG_TURNING_FROM_LEFT_UP,RocksMore_id,14+6*16},
		{IMG_BUG_TURNING_FROM_DOWN_LEFT,RocksMore_id,10+6*16},
		{IMG_SPACESHIP,RocksElements_id,8+3*16},
		{IMG_SPACESHIP_RIGHT,RocksElements_id,8+3*16},
		{IMG_SPACESHIP_UP,RocksElements_id,9+3*16},
		{IMG_SPACESHIP_LEFT,RocksElements_id,10+3*16},
		{IMG_SPACESHIP_DOWN,RocksElements_id,11+3*16},
		{IMG_SPACESHIP_MOVING_RIGHT,RocksElements_id,14*16},
		{IMG_SPACESHIP_MOVING_UP,RocksElements_id,2+14*16},
		{IMG_SPACESHIP_MOVING_LEFT,RocksElements_id,4+14*16},
		{IMG_SPACESHIP_MOVING_DOWN,RocksElements_id,6+14*16},
		{IMG_SPACESHIP_TURNING_FROM_RIGHT_UP,RocksMore_id,5*16},
		{IMG_SPACESHIP_TURNING_FROM_UP_LEFT,RocksMore_id,12+5*16},
		{IMG_SPACESHIP_TURNING_FROM_LEFT_DOWN,RocksMore_id,8+5*16},
		{IMG_SPACESHIP_TURNING_FROM_DOWN_RIGHT,RocksMore_id,4+5*16},
		{IMG_SPACESHIP_TURNING_FROM_RIGHT_DOWN,RocksMore_id,5+5*16},
		{IMG_SPACESHIP_TURNING_FROM_UP_RIGHT,RocksMore_id,1+5*16},
		{IMG_SPACESHIP_TURNING_FROM_LEFT_UP,RocksMore_id,13+5*16},
		{IMG_SPACESHIP_TURNING_FROM_DOWN_LEFT,RocksMore_id,9+5*16},
		{IMG_YAMYAM,RocksElements_id,5*16},
		{IMG_ROBOT,RocksElements_id,5*16+4},
		{IMG_ROBOT_WHEEL,RocksElements_id,6*16},
		{IMG_MAGIC_WALL,RocksElements_id,8*16},
		{IMG_QUICKSAND_EMPTY,RocksElements_id,2},
		{IMG_QUICKSAND_FILLING,RocksElements_id,3},
		{IMG_ACID_POOL_TOPLEFT,RocksElements_id,1*16},
		{IMG_ACID_POOL_TOPRIGHT,RocksElements_id,2+1*16},
		{IMG_ACID_POOL_BOTTOMLEFT,RocksElements_id,2*16},
		{IMG_ACID_POOL_BOTTOM,RocksElements_id,1+2*16},
		{IMG_ACID_POOL_BOTTOMRIGHT,RocksElements_id,2+2*16},
		{IMG_ACID,RocksElements_id,12+7*16},
		{IMG_ACID_SPLASH_LEFT,RocksHeroes_id,8+10*16},
		{IMG_ACID_SPLASH_RIGHT,RocksHeroes_id,12+10*16},
		{IMG_AMOEBA_DROP,RocksElements_id,5+6*16},
		{IMG_AMOEBA_WET,RocksElements_id,8+6*16},
		{IMG_AMOEBA_DEAD,RocksElements_id,12+6*16},
		{IMG_EM_KEY_1,RocksSP_id,4+6*16},
		{IMG_EM_KEY_2,RocksSP_id,5+6*16},
		{IMG_EM_KEY_3,RocksSP_id,6+6*16},
		{IMG_EM_KEY_4,RocksSP_id,7+6*16},
		{IMG_EM_GATE_1,RocksSP_id,7*16},
		{IMG_EM_GATE_2,RocksSP_id,1+7*16},
		{IMG_EM_GATE_3,RocksSP_id,2+7*16},
		{IMG_EM_GATE_4,RocksSP_id,3+7*16},
		{IMG_EM_GATE_1_GRAY,RocksSP_id,4+7*16},
		{IMG_EM_GATE_2_GRAY,RocksSP_id,5+7*16},
		{IMG_EM_GATE_3_GRAY,RocksSP_id,6+7*16},
		{IMG_EM_GATE_4_GRAY,RocksSP_id,7+7*16},
		{IMG_EXIT_CLOSED,RocksElements_id,11*16},
		{IMG_EXIT_OPEN,RocksElements_id,4+11*16},
		{IMG_BALLOON,RocksDC_id,12+7*16},
		{IMG_BALLOON_MOVING,RocksDC_id,12+7*16},
		{IMG_BALLOON_PUSHING,RocksDC_id,12+7*16},
		{IMG_BALLOON_SWITCH_LEFT,RocksDC_id,8+7*16},
		{IMG_BALLOON_SWITCH_RIGHT,RocksDC_id,9+7*16},
		{IMG_BALLOON_SWITCH_UP,RocksDC_id,10+7*16},
		{IMG_BALLOON_SWITCH_DOWN,RocksDC_id,11+7*16},
		{IMG_BALLOON_SWITCH_ANY,RocksDC_id,15},
		{IMG_SPRING,RocksDC_id,8+13*16},
		{IMG_EMC_STEELWALL_1,RocksDC_id,14},
		{IMG_EMC_STEELWALL_2,RocksDC_id,14},
		{IMG_EMC_STEELWALL_3,RocksDC_id,14},
		{IMG_EMC_STEELWALL_4,RocksDC_id,14},
		{IMG_EMC_WALL_1,RocksDC_id,13+6*16},
		{IMG_EMC_WALL_2,RocksDC_id,14+6*16},
		{IMG_EMC_WALL_3,RocksDC_id,15+6*16},
		{IMG_EMC_WALL_4,RocksDC_id,14+1*16},
		{IMG_EMC_WALL_5,RocksDC_id,15+1*16},
		{IMG_EMC_WALL_6,RocksDC_id,14+2*16},
		{IMG_EMC_WALL_7,RocksDC_id,15+2*16},
		{IMG_EMC_WALL_8,RocksDC_id,14+1*16},
		{IMG_INVISIBLE_STEELWALL,RocksSP_id,3+5*16},
		{IMG_INVISIBLE_STEELWALL_ACTIVE,RocksSP_id,1+5*16},
		{IMG_INVISIBLE_WALL,RocksSP_id,7+5*16},
		{IMG_INVISIBLE_WALL_ACTIVE,RocksSP_id,5+5*16},
		{IMG_INVISIBLE_SAND,RocksSP_id,6+5*16},
		{IMG_INVISIBLE_SAND_ACTIVE,RocksSP_id,2+5*16},
		{IMG_CONVEYOR_BELT_1_MIDDLE,RocksDC_id,0},
		{IMG_CONVEYOR_BELT_1_MIDDLE_ACTIVE,RocksDC_id,0},
		{IMG_CONVEYOR_BELT_1_LEFT,RocksDC_id,1*16},
		{IMG_CONVEYOR_BELT_1_LEFT_ACTIVE,RocksDC_id,1*16},
		{IMG_CONVEYOR_BELT_1_RIGHT,RocksDC_id,2*16},
		{IMG_CONVEYOR_BELT_1_RIGHT_ACTIVE,RocksDC_id,2*16},
		{IMG_CONVEYOR_BELT_1_SWITCH_LEFT,RocksDC_id,12*16},
		{IMG_CONVEYOR_BELT_1_SWITCH_MIDDLE,RocksDC_id,13*16},
		{IMG_CONVEYOR_BELT_1_SWITCH_RIGHT,RocksDC_id,14*16},
		{IMG_CONVEYOR_BELT_2_MIDDLE,RocksDC_id,3*16},
		{IMG_CONVEYOR_BELT_2_MIDDLE_ACTIVE,RocksDC_id,3*16},
		{IMG_CONVEYOR_BELT_2_LEFT,RocksDC_id,4*16},
		{IMG_CONVEYOR_BELT_2_LEFT_ACTIVE,RocksDC_id,4*16},
		{IMG_CONVEYOR_BELT_2_RIGHT,RocksDC_id,5*16},
		{IMG_CONVEYOR_BELT_2_RIGHT_ACTIVE,RocksDC_id,5*16},
		{IMG_CONVEYOR_BELT_2_SWITCH_LEFT,RocksDC_id,1+12*16},
		{IMG_CONVEYOR_BELT_2_SWITCH_MIDDLE,RocksDC_id,1+13*16},
		{IMG_CONVEYOR_BELT_2_SWITCH_RIGHT,RocksDC_id,1+14*16},
		{IMG_CONVEYOR_BELT_3_MIDDLE,RocksDC_id,6*16},
		{IMG_CONVEYOR_BELT_3_MIDDLE_ACTIVE,RocksDC_id,6*16},
		{IMG_CONVEYOR_BELT_3_LEFT,RocksDC_id,7*16},
		{IMG_CONVEYOR_BELT_3_LEFT_ACTIVE,RocksDC_id,7*16},
		{IMG_CONVEYOR_BELT_3_RIGHT,RocksDC_id,8*16},
		{IMG_CONVEYOR_BELT_3_RIGHT_ACTIVE,RocksDC_id,8*16},
		{IMG_CONVEYOR_BELT_3_SWITCH_LEFT,RocksDC_id,2+12*16},
		{IMG_CONVEYOR_BELT_3_SWITCH_MIDDLE,RocksDC_id,2+13*16},
		{IMG_CONVEYOR_BELT_3_SWITCH_RIGHT,RocksDC_id,2+14*16},
		{IMG_CONVEYOR_BELT_4_MIDDLE,RocksDC_id,9*16},
		{IMG_CONVEYOR_BELT_4_MIDDLE_ACTIVE,RocksDC_id,9*16},
		{IMG_CONVEYOR_BELT_4_LEFT,RocksDC_id,10*16},
		{IMG_CONVEYOR_BELT_4_LEFT_ACTIVE,RocksDC_id,10*16},
		{IMG_CONVEYOR_BELT_4_RIGHT,RocksDC_id,11*16},
		{IMG_CONVEYOR_BELT_4_RIGHT_ACTIVE,RocksDC_id,11*16},
		{IMG_CONVEYOR_BELT_4_SWITCH_LEFT,RocksDC_id,3+12*16},
		{IMG_CONVEYOR_BELT_4_SWITCH_MIDDLE,RocksDC_id,3+13*16},
		{IMG_CONVEYOR_BELT_4_SWITCH_RIGHT,RocksDC_id,3+14*16},
		{IMG_SWITCHGATE_SWITCH_UP,RocksDC_id,4+12*16},
		{IMG_SWITCHGATE_SWITCH_DOWN,RocksDC_id,5+12*16},
		{IMG_LIGHT_SWITCH,RocksDC_id,6+12*16},
		{IMG_LIGHT_SWITCH_ACTIVE,RocksDC_id,7+12*16},
		{IMG_TIMEGATE_SWITCH,RocksDC_id,15*16},
		{IMG_TIMEGATE_SWITCH_ACTIVE,RocksDC_id,15*16},
		{IMG_ENVELOPE_1,RocksMore_id,4*16},
		{IMG_ENVELOPE_2,RocksMore_id,1+4*16},
		{IMG_ENVELOPE_3,RocksMore_id,2+4*16},
		{IMG_ENVELOPE_4,RocksMore_id,3+4*16},
		{IMG_SIGN_EXCLAMATION,RocksDC_id,5+14*16},
		{IMG_SIGN_STOP,RocksDC_id,6+14*16},
		{IMG_LANDMINE,RocksDC_id,7+14*16},
		{IMG_STEELWALL_SLIPPERY,RocksDC_id,5+15*16},
		{IMG_EXTRA_TIME,RocksDC_id,8},
		{IMG_SHIELD_NORMAL,RocksDC_id,8+2*16},
		{IMG_SHIELD_NORMAL_ACTIVE,RocksHeroes_id,1+13*16},
		{IMG_SHIELD_DEADLY,RocksDC_id,8+1*16},
		{IMG_SHIELD_DEADLY_ACTIVE,RocksHeroes_id,5+13*16},
		{IMG_SWITCHGATE_CLOSED,RocksDC_id,8+5*16},
		{IMG_SWITCHGATE_OPEN,RocksDC_id,12+5*16},
		{IMG_TIMEGATE_CLOSED,RocksDC_id,8+6*16},
		{IMG_TIMEGATE_OPEN,RocksDC_id,12+6*16},
		{IMG_PEARL,RocksDC_id,8+11*16},
		{IMG_PEARL_BREAKING,RocksDC_id,8+12*16},
		{IMG_CRYSTAL,RocksDC_id,9+11*16},
		{IMG_WALL_PEARL,RocksDC_id,10+11*16},
		{IMG_WALL_CRYSTAL,RocksDC_id,11+11*16},
		{IMG_TUBE_RIGHT_DOWN,RocksDC_id,9+13*16},
		{IMG_TUBE_HORIZONTAL_DOWN,RocksDC_id,10+13*16},
		{IMG_TUBE_LEFT_DOWN,RocksDC_id,11+13*16},
		{IMG_TUBE_HORIZONTAL,RocksDC_id,8+14*16},
		{IMG_TUBE_VERTICAL_RIGHT,RocksDC_id,9+14*16},
		{IMG_TUBE_ANY,RocksDC_id,10+14*16},
		{IMG_TUBE_VERTICAL_LEFT,RocksDC_id,11+14*16},
		{IMG_TUBE_VERTICAL,RocksDC_id,8+15*16},
		{IMG_TUBE_RIGHT_UP,RocksDC_id,9+15*16},
		{IMG_TUBE_HORIZONTAL_UP,RocksDC_id,10+15*16},
		{IMG_TUBE_LEFT_UP,RocksDC_id,11+15*16},
		{IMG_TRAP,RocksDC_id,12+8*16},
		{IMG_TRAP_ACTIVE,RocksDC_id,12+8*16},
		{IMG_DX_SUPABOMB,RocksDC_id,15+9*16},
		{IMG_KEY_1,RocksElements_id,4+1*16},
		{IMG_KEY_2,RocksElements_id,5+1*16},
		{IMG_KEY_3,RocksElements_id,6+1*16},
		{IMG_KEY_4,RocksElements_id,7+1*16},
		{IMG_GATE_1,RocksElements_id,4+2*16},
		{IMG_GATE_2,RocksElements_id,5+2*16},
		{IMG_GATE_3,RocksElements_id,6+2*16},
		{IMG_GATE_4,RocksElements_id,7+2*16},
		{IMG_GATE_1_GRAY,RocksElements_id,8+2*16},
		{IMG_GATE_2_GRAY,RocksElements_id,9+2*16},
		{IMG_GATE_3_GRAY,RocksElements_id,10+2*16},
		{IMG_GATE_4_GRAY,RocksElements_id,11+2*16},
		{IMG_GAME_OF_LIFE,RocksElements_id,8+1*16},
		{IMG_BIOMAZE,RocksElements_id,9+1*16},
		{IMG_PACMAN,RocksElements_id,8+5*16},
		{IMG_PACMAN_RIGHT,RocksElements_id,8+5*16},
		{IMG_PACMAN_UP,RocksElements_id,12+5*16},
		{IMG_PACMAN_LEFT,RocksElements_id,10+5*16},
		{IMG_PACMAN_DOWN,RocksElements_id,14+5*16},
		{IMG_PACMAN_TURNING_FROM_RIGHT,RocksElements_id,9+5*16},
		{IMG_PACMAN_TURNING_FROM_UP,RocksElements_id,13+5*16},
		{IMG_PACMAN_TURNING_FROM_LEFT,RocksElements_id,11+5*16},
		{IMG_PACMAN_TURNING_FROM_DOWN,RocksElements_id,15+5*16},
		{IMG_LAMP,RocksElements_id,7*16},
		{IMG_LAMP_ACTIVE,RocksElements_id,1+7*16},
		{IMG_TIME_ORB_FULL,RocksElements_id,2+7*16},
		{IMG_TIME_ORB_EMPTY,RocksElements_id,3+7*16},
		{IMG_EMERALD_YELLOW,RocksElements_id,10+8*16},
		{IMG_EMERALD_RED,RocksElements_id,8+9*16},
		{IMG_EMERALD_PURPLE,RocksElements_id,10+9*16},
		{IMG_WALL_EMERALD_YELLOW,RocksElements_id,8+8*16},
		{IMG_WALL_EMERALD_RED,RocksElements_id,6+8*16},
		{IMG_WALL_EMERALD_PURPLE,RocksElements_id,7+8*16},
		{IMG_WALL_BD_DIAMOND,RocksElements_id,9+8*16},
		{IMG_EXPANDABLE_WALL,RocksElements_id,11+10*16},
		{IMG_EXPANDABLE_WALL_HORIZONTAL,RocksElements_id,5+9*16},
		{IMG_EXPANDABLE_WALL_VERTICAL,RocksElements_id,6+9*16},
		{IMG_EXPANDABLE_WALL_ANY,RocksElements_id,4+9*16},
		{IMG_EXPANDABLE_WALL_GROWING_LEFT,RocksElements_id,8+10*16},
		{IMG_EXPANDABLE_WALL_GROWING_RIGHT,RocksElements_id,5+10*16},
		{IMG_EXPANDABLE_WALL_GROWING_UP,RocksHeroes_id,3+12*16},
		{IMG_EXPANDABLE_WALL_GROWING_DOWN,RocksHeroes_id,12*16},		
		{IMG_BLACK_ORB,RocksElements_id,13+9*16},
		{IMG_SPEED_PILL,RocksElements_id,14+9*16},
		{IMG_DARK_YAMYAM,RocksElements_id,8+11*16},
		{IMG_DYNABOMB,RocksElements_id,12+11*16},
		{IMG_DYNABOMB_ACTIVE,RocksElements_id,12+11*16},
		{IMG_DYNABOMB_PLAYER_1,RocksElements_id,12+11*16},
		{IMG_DYNABOMB_PLAYER_1_ACTIVE,RocksElements_id,12+11*16},
		{IMG_DYNABOMB_PLAYER_2,RocksElements_id,12+11*16},
		{IMG_DYNABOMB_PLAYER_2_ACTIVE,RocksElements_id,12+11*16},
		{IMG_DYNABOMB_PLAYER_3,RocksElements_id,12+11*16},
		{IMG_DYNABOMB_PLAYER_3_ACTIVE,RocksElements_id,12+11*16},
		{IMG_DYNABOMB_PLAYER_4,RocksElements_id,12+11*16},
		{IMG_DYNABOMB_PLAYER_4_ACTIVE,RocksElements_id,12+11*16},
		{IMG_DYNABOMB_INCREASE_NUMBER,RocksElements_id,12+11*16},
		{IMG_DYNABOMB_INCREASE_SIZE,RocksElements_id,15+11*16},
		{IMG_DYNABOMB_INCREASE_POWER,RocksElements_id,12+9*16},
		{IMG_PIG,RocksHeroes_id,8},
		{IMG_PIG_DOWN,RocksHeroes_id,8},
		{IMG_PIG_UP,RocksHeroes_id,12},
		{IMG_PIG_LEFT,RocksHeroes_id,8+1*16},
		{IMG_PIG_RIGHT,RocksHeroes_id,12+1*16},
		{IMG_DRAGON,RocksHeroes_id,8+2*16},
		{IMG_DRAGON_DOWN,RocksHeroes_id,8+2*16},
		{IMG_DRAGON_UP,RocksHeroes_id,12+2*16},
		{IMG_DRAGON_LEFT,RocksHeroes_id,8+3*16},
		{IMG_DRAGON_RIGHT,RocksHeroes_id,12+3*16},
		{IMG_MOLE,RocksHeroes_id,8+4*16},
		{IMG_MOLE_DOWN,RocksHeroes_id,8+4*16},
		{IMG_MOLE_UP,RocksHeroes_id,12+4*16},
		{IMG_MOLE_LEFT,RocksHeroes_id,8+5*16},
		{IMG_MOLE_RIGHT,RocksHeroes_id,12+5*16},
		{IMG_PENGUIN,RocksHeroes_id,8+6*16},
		{IMG_PENGUIN_DOWN,RocksHeroes_id,8+6*16},
		{IMG_PENGUIN_UP,RocksHeroes_id,12+6*16},
		{IMG_PENGUIN_LEFT,RocksHeroes_id,8+7*16},
		{IMG_PENGUIN_RIGHT,RocksHeroes_id,12+7*16},
		{IMG_SATELLITE,RocksHeroes_id,8+9*16},
		{IMG_FLAMES_1_LEFT,RocksHeroes_id,8+12*16},
		{IMG_FLAMES_2_LEFT,RocksHeroes_id,10+12*16},
		{IMG_FLAMES_3_LEFT,RocksHeroes_id,12+12*16},
		{IMG_FLAMES_1_RIGHT,RocksHeroes_id,8+13*16},
		{IMG_FLAMES_2_RIGHT,RocksHeroes_id,10+13*16},
		{IMG_FLAMES_3_RIGHT,RocksHeroes_id,12+13*16},
		{IMG_FLAMES_1_UP,RocksHeroes_id,8+14*16},
		{IMG_FLAMES_2_UP,RocksHeroes_id,10+14*16},
		{IMG_FLAMES_3_UP,RocksHeroes_id,12+14*16},
		{IMG_FLAMES_1_DOWN,RocksHeroes_id,8+15*16},
		{IMG_FLAMES_2_DOWN,RocksHeroes_id,10+15*16},
		{IMG_FLAMES_3_DOWN,RocksHeroes_id,12+15*16},
		{IMG_STONEBLOCK,RocksElements_id,10+1*16},
		{IMG_PLAYER_1,RocksHeroes_id,0},
		{IMG_PLAYER_1_DOWN,RocksHeroes_id,0},
		{IMG_PLAYER_1_UP,RocksHeroes_id,4},
		{IMG_PLAYER_1_LEFT,RocksHeroes_id,1*16},
		{IMG_PLAYER_1_RIGHT,RocksHeroes_id,4+1*16},
		{IMG_PLAYER_1_PUSHING_LEFT,RocksHeroes_id,4+2*16},
		{IMG_PLAYER_1_PUSHING_RIGHT,RocksHeroes_id,2*16},
				
		{IMG_PLAYER_2,RocksHeroes_id,3*16},
		{IMG_PLAYER_3,RocksHeroes_id,6*16},
		{IMG_PLAYER_4,RocksHeroes_id,9*16},

		{IMG_DEFAULT_EXPLODING,RocksElements_id,4*16},
		
		{IMG_TWINKLE_WHITE,RocksHeroes_id,13+11*16},
		{IMG_STEELWALL_TOPLEFT,RocksElements_id,4},
		{IMG_INVISIBLE_STEELWALL_TOPLEFT,RocksSP_id,0},
		
		{IMG_CHAR_SPACE,RocksFontEM_id,0},
		{IMG_CHAR_EXCLAM,RocksFontEM_id,1},		
		{IMG_CHAR_QUOTEDBL,RocksFontEM_id,2},		
		{IMG_CHAR_NUMBERSIGN,RocksFontEM_id,3},		
		{IMG_CHAR_DOLLAR,RocksFontEM_id,4},		
		{IMG_CHAR_PROCENT,RocksFontEM_id,5},		
		{IMG_CHAR_AMPERSAND,RocksFontEM_id,6},		
		{IMG_CHAR_APOSTROPHE,RocksFontEM_id,7},		
		{IMG_CHAR_PARENLEFT,RocksFontEM_id,8},		
		{IMG_CHAR_PARENRIGHT,RocksFontEM_id,9},		
		{IMG_CHAR_ASTERISK,RocksFontEM_id,10},		
		{IMG_CHAR_PLUS,RocksFontEM_id,11},		
		{IMG_CHAR_COMMA,RocksFontEM_id,12},		
		{IMG_CHAR_MINUS,RocksFontEM_id,13},		
		{IMG_CHAR_PERIOD,RocksFontEM_id,14},		
		{IMG_CHAR_SLASH,RocksFontEM_id,15},		
		{IMG_CHAR_0,RocksFontEM_id,1*16},
		{IMG_CHAR_1,RocksFontEM_id,1*16+1},
		{IMG_CHAR_2,RocksFontEM_id,1*16+2},
		{IMG_CHAR_3,RocksFontEM_id,1*16+3},
		{IMG_CHAR_4,RocksFontEM_id,1*16+4},
		{IMG_CHAR_5,RocksFontEM_id,1*16+5},
		{IMG_CHAR_6,RocksFontEM_id,1*16+6},
		{IMG_CHAR_7,RocksFontEM_id,1*16+7},
		{IMG_CHAR_8,RocksFontEM_id,1*16+8},
		{IMG_CHAR_9,RocksFontEM_id,1*16+9},
		{IMG_CHAR_COLON,RocksFontEM_id,1*16+10},
		{IMG_CHAR_SEMICOLON,RocksFontEM_id,1*16+11},
		{IMG_CHAR_LESS,RocksFontEM_id,1*16+12},
		{IMG_CHAR_EQUAL,RocksFontEM_id,1*16+13},
		{IMG_CHAR_GREATER,RocksFontEM_id,1*16+14},
		{IMG_CHAR_QUESTION,RocksFontEM_id,1*16+15},
		{IMG_CHAR_AT,RocksFontEM_id,2*16},
		{IMG_CHAR_A,RocksFontEM_id,2*16+1},
		{IMG_CHAR_B,RocksFontEM_id,2*16+2},
		{IMG_CHAR_C,RocksFontEM_id,2*16+3},
		{IMG_CHAR_D,RocksFontEM_id,2*16+4},
		{IMG_CHAR_E,RocksFontEM_id,2*16+5},
		{IMG_CHAR_F,RocksFontEM_id,2*16+6},
		{IMG_CHAR_G,RocksFontEM_id,2*16+7},
		{IMG_CHAR_H,RocksFontEM_id,2*16+8},
		{IMG_CHAR_I,RocksFontEM_id,2*16+9},
		{IMG_CHAR_J,RocksFontEM_id,2*16+10},
		{IMG_CHAR_K,RocksFontEM_id,2*16+11},
		{IMG_CHAR_L,RocksFontEM_id,2*16+12},
		{IMG_CHAR_M,RocksFontEM_id,2*16+13},
		{IMG_CHAR_N,RocksFontEM_id,2*16+14},
		{IMG_CHAR_O,RocksFontEM_id,2*16+15},
		{IMG_CHAR_P,RocksFontEM_id,3*16},
		{IMG_CHAR_Q,RocksFontEM_id,3*16+1},
		{IMG_CHAR_R,RocksFontEM_id,3*16+2},
		{IMG_CHAR_S,RocksFontEM_id,3*16+3},
		{IMG_CHAR_T,RocksFontEM_id,3*16+4},
		{IMG_CHAR_U,RocksFontEM_id,3*16+5},
		{IMG_CHAR_V,RocksFontEM_id,3*16+6},
		{IMG_CHAR_W,RocksFontEM_id,3*16+7},
		{IMG_CHAR_X,RocksFontEM_id,3*16+8},
		{IMG_CHAR_Y,RocksFontEM_id,3*16+9},
		{IMG_CHAR_Z,RocksFontEM_id,3*16+10},
		{IMG_CHAR_BRACKETLEFT,RocksFontEM_id,3*16+11},
		{IMG_CHAR_BACKSLASH,RocksFontEM_id,3*16+12},
		{IMG_CHAR_BRACKETRIGHT,RocksFontEM_id,3*16+13},
		{IMG_CHAR_ASCIICIRCUM,RocksFontEM_id,3*16+14},
		{IMG_CHAR_UNDERSCORE,RocksFontEM_id,3*16+15},
		{IMG_CHAR_COPYRIGHT,RocksFontEM_id,4*16},
		{IMG_CHAR_AUMLAUT,RocksFontEM_id,4*16+1},
		{IMG_CHAR_OUMLAUT,RocksFontEM_id,4*16+2},
		{IMG_CHAR_UUMLAUT,RocksFontEM_id,4*16+3},
		{IMG_CHAR_DEGREE,RocksFontEM_id,4*16+4},
		{IMG_CHAR_TRADEMARK,RocksFontEM_id,4*16+5},
		{IMG_CHAR_CURSOR,RocksFontEM_id,4*16+6},
		{-1,0,0}
	};
	
	int src;
	
	const int copy_graphics[] =
	{
		IMG_BD_ROCK,
			IMG_BD_ROCK_MOVING_LEFT,
			IMG_BD_ROCK_MOVING_RIGHT,
			IMG_BD_ROCK_PUSHING_LEFT,
			IMG_BD_ROCK_PUSHING_RIGHT,
			-1,
			
		IMG_BD_DIAMOND_MOVING,
			IMG_BD_DIAMOND_FALLING,
			-1,
		
		IMG_BD_MAGIC_WALL,
			IMG_BD_MAGIC_WALL_ACTIVE,
			IMG_BD_MAGIC_WALL_FILLING,
			IMG_BD_MAGIC_WALL_FULL,
			IMG_BD_MAGIC_WALL_EMPTYING,
			IMG_BD_MAGIC_WALL_DEAD,
			-1,
		
		IMG_SP_ZONK_MOVING_LEFT,
			IMG_SP_ZONK_MOVING_RIGHT,
			IMG_SP_ZONK_PUSHING_LEFT,
			IMG_SP_ZONK_PUSHING_RIGHT,
			-1,
		
		IMG_SP_MURPHY_MOVING_LEFT,
			IMG_SP_MURPHY_DIGGING_LEFT,
			IMG_SP_MURPHY_COLLECTING_LEFT,
			-1,
			
		IMG_SP_MURPHY_MOVING_RIGHT,
			IMG_SP_MURPHY_DIGGING_RIGHT,
			IMG_SP_MURPHY_COLLECTING_RIGHT,
			-1,

		IMG_SP_EXIT_CLOSED,
			IMG_SP_EXIT_OPENING,
			IMG_SP_EXIT_OPEN,
			IMG_SP_EXIT_CLOSING,
			-1,
			
		IMG_ROCK,
			IMG_ROCK_MOVING_LEFT,
			IMG_ROCK_MOVING_RIGHT,
			IMG_ROCK_PUSHING_LEFT,
			IMG_ROCK_PUSHING_RIGHT,
			-1,
		
		IMG_EMERALD,
			IMG_EMERALD_MOVING,
			IMG_EMERALD_FALLING,
			-1,
			
		IMG_DIAMOND,
			IMG_DIAMOND_MOVING,
			IMG_DIAMOND_FALLING,
			-1,

		IMG_ROBOT_WHEEL,
			IMG_ROBOT_WHEEL_ACTIVE,
			-1,

		IMG_YAMYAM,
			IMG_YAMYAM_MOVING,
			-1,

		IMG_ROBOT,
			IMG_ROBOT_MOVING,
			-1,

		IMG_MAGIC_WALL,
			IMG_MAGIC_WALL_ACTIVE,
			IMG_MAGIC_WALL_FILLING,
			IMG_MAGIC_WALL_FULL,
			IMG_MAGIC_WALL_EMPTYING,
			IMG_MAGIC_WALL_DEAD,
			-1,
			
		IMG_QUICKSAND_FILLING,
			IMG_QUICKSAND_FULL,
			IMG_QUICKSAND_EMPTYING,
			-1,

		IMG_AMOEBA_DROP,
			IMG_AMOEBA_GROWING,
			IMG_AMOEBA_SHRINKING,
			-1,

		IMG_AMOEBA_WET,
			IMG_AMOEBA_DROPPING,
			IMG_AMOEBA_DRY,
			IMG_AMOEBA_FULL,
			-1,

		IMG_EXIT_CLOSED,
			IMG_EXIT_OPENING,
			IMG_EXIT_CLOSING,
			-1,

		IMG_SWITCHGATE_CLOSED,
			IMG_SWITCHGATE_OPENING,
			IMG_SWITCHGATE_CLOSING,
			-1,

		IMG_TIMEGATE_CLOSED,
			IMG_TIMEGATE_OPENING,
			IMG_TIMEGATE_CLOSING,
			-1,
		
		IMG_EMERALD_YELLOW,
			IMG_EMERALD_YELLOW_MOVING,
			IMG_EMERALD_YELLOW_FALLING,
			-1,

		IMG_PLAYER_1_DOWN,
			IMG_PLAYER_1_MOVING_DOWN,
			IMG_PLAYER_1_DIGGING_DOWN,
			IMG_PLAYER_1_COLLECTING_DOWN,
			IMG_PLAYER_1_PUSHING_DOWN,
			IMG_PLAYER_1_SNAPPING_DOWN,
			-1,
			
		IMG_PLAYER_1_UP,
			IMG_PLAYER_1_MOVING_UP,
			IMG_PLAYER_1_DIGGING_UP,
			IMG_PLAYER_1_COLLECTING_UP,
			IMG_PLAYER_1_PUSHING_UP,
			IMG_PLAYER_1_SNAPPING_UP,
			-1,
		
		IMG_PLAYER_1_LEFT,
			IMG_PLAYER_1_MOVING_LEFT,
			IMG_PLAYER_1_DIGGING_LEFT,
			IMG_PLAYER_1_COLLECTING_LEFT,
			IMG_PLAYER_1_SNAPPING_LEFT,
			-1,
			
		IMG_PLAYER_1_RIGHT,
			IMG_PLAYER_1_MOVING_RIGHT,
			IMG_PLAYER_1_DIGGING_RIGHT,
			IMG_PLAYER_1_COLLECTING_RIGHT,
			IMG_PLAYER_1_SNAPPING_RIGHT,
			-1,

		IMG_STEELWALL_TOPLEFT,
			IMG_STEELWALL_TOPRIGHT,
			IMG_STEELWALL_BOTTOMLEFT,
			IMG_STEELWALL_BOTTOMRIGHT,
			IMG_STEELWALL_HORIZONTAL,
			IMG_STEELWALL_VERTICAL,
			-1,
			
		IMG_INVISIBLE_STEELWALL_TOPLEFT,
			IMG_INVISIBLE_STEELWALL_TOPRIGHT,
			IMG_INVISIBLE_STEELWALL_BOTTOMLEFT,
			IMG_INVISIBLE_STEELWALL_BOTTOMRIGHT,
			IMG_INVISIBLE_STEELWALL_HORIZONTAL,
			IMG_INVISIBLE_STEELWALL_VERTICAL,
			-1,
			
		-1,
	};

	const struct 
		{short int no;byte anim_frames;byte anim_mode;
			byte anim_delay;byte anim_start_frame;boolean global_sync;}
	DefAnimInfo[]=
	{
		{0,1,ANIM_NONE,1,0,FALSE},//it will generate anim_index=1
		{IMG_BD_ROCK_MOVING_LEFT,4,ANIM_DEFAULT|ANIM_REVERSE,2,0,FALSE},
		{IMG_BD_ROCK_MOVING_RIGHT,4,ANIM_DEFAULT,2,1,FALSE},
		{IMG_BD_DIAMOND,4,ANIM_DEFAULT|ANIM_REVERSE,4,0,FALSE},
		{IMG_BD_DIAMOND_MOVING,2,ANIM_DEFAULT,4,0,FALSE},
		{IMG_BD_MAGIC_WALL_ACTIVE,4,ANIM_DEFAULT|ANIM_REVERSE,4,0,TRUE},
		{IMG_BD_AMOEBA,4,ANIM_RANDOM,DELAY_MILLION,0,FALSE},
		{IMG_BD_BUTTERFLY,2,ANIM_PINGPONG,4,0,TRUE},
		{IMG_BD_FIREFLY,2,ANIM_PINGPONG,4,0,TRUE},
		{IMG_SP_DEFAULT_EXPLODING,8,ANIM_LINEAR,3,0,FALSE},
		{IMG_SP_MURPHY_MOVING_LEFT,3,ANIM_PINGPONG,2,0,FALSE},
		{IMG_SP_SNIKSNAK_LEFT,4,ANIM_PINGPONG2,1,0,FALSE},
		{IMG_SP_SNIKSNAK_TURNING_FROM_LEFT_UP,2,ANIM_LINEAR,4,0,FALSE},
		{IMG_SP_ELECTRON,8,ANIM_DEFAULT,4,0,TRUE},
		{IMG_SP_TERMINAL,7,ANIM_DEFAULT,12,0,FALSE},
		{IMG_SP_TERMINAL_ACTIVE,7,ANIM_DEFAULT,4,0,FALSE},
		{IMG_SP_BUGGY_BASE_ACTIVE,4,ANIM_RANDOM,1,0,FALSE},
		{IMG_SAND_DIGGING_LEFT,3,ANIM_LINEAR,2,0,FALSE},
		{IMG_NUT_BREAKING,3,ANIM_LINEAR,2,0,FALSE},
		{IMG_DYNAMITE_ACTIVE,7,ANIM_LINEAR,12,0,FALSE},
		{IMG_BUG_TURNING_FROM_RIGHT_UP,4,ANIM_LINEAR|ANIM_REVERSE,2,0,FALSE},
		{IMG_BUG_TURNING_FROM_RIGHT_DOWN,4,ANIM_LINEAR,2,0,FALSE},
		{IMG_ROBOT_WHEEL_ACTIVE,4,ANIM_DEFAULT,1,0,FALSE},
		{IMG_ACID,4,ANIM_DEFAULT,10,0,TRUE},
		{IMG_AMOEBA_GROWING,3,ANIM_LINEAR,2,0,FALSE},
		{IMG_AMOEBA_SHRINKING,3,ANIM_LINEAR|ANIM_REVERSE,2,0,FALSE},
		{IMG_EXIT_OPENING,5,ANIM_LINEAR,6,0,FALSE},
		{IMG_EXIT_OPEN,4,ANIM_PINGPONG,4,0,FALSE},
		{IMG_EXIT_CLOSING,5,ANIM_LINEAR|ANIM_REVERSE,6,0,FALSE},
		{IMG_BALLOON_MOVING,4,ANIM_PINGPONG,2,0,FALSE},
		{IMG_BALLOON_PUSHING,4,ANIM_PINGPONG,2,0,FALSE},
		{IMG_CONVEYOR_BELT_1_MIDDLE_ACTIVE,8,ANIM_DEFAULT,2,0,FALSE},
		{IMG_CONVEYOR_BELT_1_MIDDLE_ACTIVE,8,ANIM_DEFAULT,2,0,FALSE},
		{IMG_CONVEYOR_BELT_1_LEFT_ACTIVE,8,ANIM_DEFAULT,2,0,FALSE},
		{IMG_CONVEYOR_BELT_1_RIGHT_ACTIVE,8,ANIM_DEFAULT,2,0,FALSE},
		{IMG_CONVEYOR_BELT_2_MIDDLE_ACTIVE,8,ANIM_DEFAULT,2,0,FALSE},
		{IMG_CONVEYOR_BELT_2_LEFT_ACTIVE,8,ANIM_DEFAULT,2,0,FALSE},
		{IMG_CONVEYOR_BELT_2_RIGHT_ACTIVE,8,ANIM_DEFAULT,2,0,FALSE},
		{IMG_CONVEYOR_BELT_3_MIDDLE_ACTIVE,8,ANIM_DEFAULT,2,0,FALSE},
		{IMG_CONVEYOR_BELT_3_LEFT_ACTIVE,8,ANIM_DEFAULT,2,0,FALSE},
		{IMG_CONVEYOR_BELT_3_RIGHT_ACTIVE,8,ANIM_DEFAULT,2,0,FALSE},
		{IMG_CONVEYOR_BELT_4_MIDDLE_ACTIVE,8,ANIM_DEFAULT,2,0,FALSE},
		{IMG_CONVEYOR_BELT_4_LEFT_ACTIVE,8,ANIM_DEFAULT,2,0,FALSE},
		{IMG_CONVEYOR_BELT_4_RIGHT_ACTIVE,8,ANIM_DEFAULT,2,0,FALSE},
		{IMG_TIMEGATE_SWITCH_ACTIVE,4,ANIM_DEFAULT,1,0,FALSE},
		{IMG_EXTRA_TIME,6,ANIM_DEFAULT,4,0,FALSE},
		{IMG_SHIELD_NORMAL,6,ANIM_DEFAULT,4,0,FALSE},
		{IMG_SHIELD_NORMAL_ACTIVE,3,ANIM_PINGPONG,8,0,FALSE},
		{IMG_SHIELD_DEADLY,6,ANIM_DEFAULT,4,0,FALSE},
		{IMG_SHIELD_DEADLY_ACTIVE,3,ANIM_PINGPONG,8,0,FALSE},
		{IMG_SWITCHGATE_OPENING,5,ANIM_DEFAULT,6,0,FALSE},
		{IMG_SWITCHGATE_CLOSING,5,ANIM_DEFAULT|ANIM_REVERSE,6,0,FALSE},
		{IMG_TIMEGATE_OPENING,5,ANIM_DEFAULT,6,0,FALSE},
		{IMG_TIMEGATE_CLOSING,5,ANIM_DEFAULT|ANIM_REVERSE,6,0,FALSE},
		{IMG_PEARL_BREAKING,4,ANIM_LINEAR,2,0,FALSE},
		{IMG_TRAP_ACTIVE,4,ANIM_PINGPONG2,4,0,FALSE},
		
		{IMG_EXPANDABLE_WALL_GROWING_LEFT,3,ANIM_LINEAR,6,0,FALSE},
		
		{IMG_DYNABOMB_ACTIVE,4,ANIM_PINGPONG,6,0,FALSE},
		{IMG_SATELLITE,8,ANIM_DEFAULT,2,0,TRUE},
		{IMG_FLAMES_1_LEFT,2,ANIM_DEFAULT,1,0,FALSE},
		{IMG_PLAYER_1_MOVING_DOWN,4,ANIM_DEFAULT,4,1,FALSE},
		{IMG_PLAYER_1_PUSHING_LEFT,4,ANIM_DEFAULT,4,0,FALSE},
		
		{IMG_DEFAULT_EXPLODING,8,ANIM_LINEAR,2,0,FALSE},
		
		{IMG_TWINKLE_WHITE,3,ANIM_PINGPONG,2,0,FALSE},
		
		{-1,0,0,0,0,FALSE}
	};

	const int copy_animation[] =
	{
		IMG_BD_ROCK_MOVING_LEFT,//4,ANIM_DEFAULT|ANIM_REVERSE,2,0,FALSE
			IMG_BD_ROCK_PUSHING_LEFT,
			IMG_SP_ZONK_MOVING_LEFT,
			IMG_SP_ZONK_PUSHING_LEFT,
			IMG_ROCK_MOVING_LEFT,
			IMG_ROCK_PUSHING_LEFT,
			-1,

		IMG_BD_ROCK_MOVING_RIGHT,//4,ANIM_DEFAULT,2,1,FALSE
			IMG_BD_ROCK_PUSHING_RIGHT,
			IMG_SP_ZONK_MOVING_RIGHT,
			IMG_SP_ZONK_PUSHING_RIGHT,
			IMG_ROCK_MOVING_RIGHT,
			IMG_ROCK_PUSHING_RIGHT,
			-1,
			
		IMG_BD_DIAMOND_MOVING,//2,ANIM_DEFAULT,4,0,FALSE
			IMG_BD_DIAMOND_FALLING,
			IMG_EMERALD_MOVING,
			IMG_EMERALD_FALLING,
			IMG_DIAMOND_MOVING,
			IMG_DIAMOND_FALLING,
			IMG_BUG_MOVING_RIGHT,
			IMG_BUG_MOVING_UP,
			IMG_BUG_MOVING_LEFT,
			IMG_BUG_MOVING_DOWN,
			IMG_SPACESHIP_MOVING_RIGHT,
			IMG_SPACESHIP_MOVING_UP,
			IMG_SPACESHIP_MOVING_LEFT,
			IMG_SPACESHIP_MOVING_DOWN,
			IMG_EMERALD_YELLOW_MOVING,
			IMG_EMERALD_YELLOW_FALLING,
			IMG_PACMAN_RIGHT,
			IMG_PACMAN_UP,
			IMG_PACMAN_LEFT,
			IMG_PACMAN_DOWN,
			-1,

		IMG_BD_MAGIC_WALL_ACTIVE,//4,ANIM_DEFAULT|ANIM_REVERSE,4,0,TRUE
			IMG_BD_MAGIC_WALL_FILLING,
			IMG_BD_MAGIC_WALL_FULL,
			IMG_BD_MAGIC_WALL_EMPTYING,
			IMG_MAGIC_WALL_ACTIVE,
			IMG_MAGIC_WALL_FILLING,
			IMG_MAGIC_WALL_FULL,
			IMG_MAGIC_WALL_EMPTYING,
			-1,
			
		IMG_BD_AMOEBA,//4,ANIM_RANDOM,DELAY_MILLION,0,FALSE
			IMG_AMOEBA_WET,
			IMG_AMOEBA_DROPPING,
			IMG_AMOEBA_DRY,
			IMG_AMOEBA_FULL,
			IMG_AMOEBA_DEAD,
			-1,
		
		IMG_SP_DEFAULT_EXPLODING,//8,ANIM_LINEAR,3,0,FALSE
			IMG_SP_ELECTRON_EXPLODING,
			-1,
		
		IMG_SP_MURPHY_MOVING_LEFT,//3,ANIM_PINGPONG,2,0,FALSE
			IMG_SP_MURPHY_MOVING_RIGHT,
			IMG_SP_MURPHY_DIGGING_LEFT,
			IMG_SP_MURPHY_DIGGING_RIGHT,
			IMG_SP_MURPHY_COLLECTING_LEFT,
			IMG_SP_MURPHY_COLLECTING_RIGHT,
			-1,
			
		IMG_SP_SNIKSNAK_LEFT,//4,ANIM_PINGPONG2,1,0,FALSE
			IMG_SP_SNIKSNAK_RIGHT,
			IMG_SP_SNIKSNAK_UP,
			IMG_SP_SNIKSNAK_DOWN,
			IMG_YAMYAM,
			IMG_ROBOT,
			IMG_DARK_YAMYAM,			
			-1,
		
		IMG_SP_SNIKSNAK_TURNING_FROM_LEFT_UP,//2,ANIM_LINEAR,4,0,FALSE
    		IMG_SP_SNIKSNAK_TURNING_FROM_LEFT_DOWN,
			IMG_SP_SNIKSNAK_TURNING_FROM_RIGHT_UP,
			IMG_SP_SNIKSNAK_TURNING_FROM_RIGHT_DOWN,
			IMG_SP_SNIKSNAK_TURNING_FROM_UP_LEFT,
			IMG_SP_SNIKSNAK_TURNING_FROM_UP_RIGHT,
			IMG_SP_SNIKSNAK_TURNING_FROM_DOWN_LEFT,
			IMG_SP_SNIKSNAK_TURNING_FROM_DOWN_RIGHT,
			-1,
		
		IMG_SAND_DIGGING_LEFT,//3,ANIM_LINEAR,2,0,FALSE
			IMG_SAND_DIGGING_RIGHT,
			IMG_SAND_DIGGING_UP,
			IMG_SAND_DIGGING_DOWN,
			IMG_EMERALD_COLLECTING,
			IMG_DIAMOND_COLLECTING,
			-1,
		
		IMG_EXPANDABLE_WALL_GROWING_LEFT,//3,ANIM_LINEAR,6,0,FALSE
			IMG_EXPANDABLE_WALL_GROWING_RIGHT,
			IMG_EXPANDABLE_WALL_GROWING_UP,
			IMG_EXPANDABLE_WALL_GROWING_DOWN,
			-1,
		
		IMG_DYNABOMB_ACTIVE,//4,ANIM_PINGPONG,6,0,FALSE
			IMG_DYNABOMB_PLAYER_1_ACTIVE,
			IMG_DYNABOMB_PLAYER_2_ACTIVE,
			IMG_DYNABOMB_PLAYER_3_ACTIVE,
			IMG_DYNABOMB_PLAYER_4_ACTIVE,
			-1,
		
		IMG_BUG_TURNING_FROM_RIGHT_UP,//4,ANIM_LINEAR|ANIM_REVERSE,2,0,FALSE
			IMG_BUG_TURNING_FROM_UP_LEFT,
			IMG_BUG_TURNING_FROM_LEFT_DOWN,
			IMG_BUG_TURNING_FROM_DOWN_RIGHT,
			IMG_SPACESHIP_TURNING_FROM_RIGHT_UP,
			IMG_SPACESHIP_TURNING_FROM_UP_LEFT,
			IMG_SPACESHIP_TURNING_FROM_LEFT_DOWN,
			IMG_SPACESHIP_TURNING_FROM_DOWN_RIGHT,
			-1,

		IMG_BUG_TURNING_FROM_RIGHT_DOWN,//4,ANIM_LINEAR,2,0,FALSE
			IMG_BUG_TURNING_FROM_UP_RIGHT,
			IMG_BUG_TURNING_FROM_LEFT_UP,
			IMG_BUG_TURNING_FROM_DOWN_LEFT,
			IMG_SPACESHIP_TURNING_FROM_RIGHT_DOWN,
			IMG_SPACESHIP_TURNING_FROM_UP_RIGHT,
			IMG_SPACESHIP_TURNING_FROM_LEFT_UP,
			IMG_SPACESHIP_TURNING_FROM_DOWN_LEFT,
			IMG_ACID_SPLASH_LEFT,
			IMG_ACID_SPLASH_RIGHT,
			-1,

		IMG_FLAMES_1_LEFT,
			IMG_FLAMES_2_LEFT,
			IMG_FLAMES_3_LEFT,
			IMG_FLAMES_1_RIGHT,
			IMG_FLAMES_2_RIGHT,
			IMG_FLAMES_3_RIGHT,
			IMG_FLAMES_1_UP,
			IMG_FLAMES_2_UP,
			IMG_FLAMES_3_UP,
			IMG_FLAMES_1_DOWN,
			IMG_FLAMES_2_DOWN,
			IMG_FLAMES_3_DOWN,
			-1,

		IMG_PLAYER_1_MOVING_DOWN,//4,ANIM_DEFAULT,4,1,FALSE
			IMG_PLAYER_1_MOVING_UP,
			IMG_PLAYER_1_MOVING_LEFT,
			IMG_PLAYER_1_MOVING_RIGHT,
			IMG_PLAYER_1_DIGGING_DOWN,
			IMG_PLAYER_1_DIGGING_UP,
			IMG_PLAYER_1_DIGGING_LEFT,
			IMG_PLAYER_1_DIGGING_RIGHT,
			IMG_PLAYER_1_COLLECTING_DOWN,
			IMG_PLAYER_1_COLLECTING_UP,
			IMG_PLAYER_1_COLLECTING_LEFT,
			IMG_PLAYER_1_COLLECTING_RIGHT,
			-1,
		
		IMG_PLAYER_1_PUSHING_LEFT,
			IMG_PLAYER_1_PUSHING_RIGHT,
			-1,
		
		-1,
	};

	int anim_idx;

	for(i=0;i<NUM_IMAGE_FILES;i++)
	{
		graphic_infoF->bmp_no[i]=RocksFontEM_id;
		graphic_infoF->x_y[i]=1*16+15;
		graphic_infoF->anim_index[i]=1;
	}
	
	for(i=0;DefGrInfo[i].no!=-1;i++)
	{
		j=DefGrInfo[i].no;
		graphic_infoF->bmp_no[j]=DefGrInfo[i].bmp_id;
		graphic_infoF->x_y[j]=DefGrInfo[i].x_y;
	}

	// copy same graphics
	i=0;
	while((src=copy_graphics[i])!=-1)
	{
		i++;
		while(copy_graphics[i]!=-1)
		{
			j=copy_graphics[i];
			graphic_infoF->bmp_no[j]=graphic_infoF->bmp_no[src];
			graphic_infoF->x_y[j]=graphic_infoF->x_y[src];
			i++;
		}
		i++;
	}

	anim_idx=1;

	for(i=0;DefAnimInfo[i].no!=-1;i++)
	{
		anim_infoF->anim_frames[anim_idx]=DefAnimInfo[i].anim_frames;
		anim_infoF->anim_mode[anim_idx]=DefAnimInfo[i].anim_mode;
		anim_infoF->anim_delay_[anim_idx]=DefAnimInfo[i].anim_delay;
		anim_infoF->anim_start_frame[anim_idx]=DefAnimInfo[i].anim_start_frame;
		anim_infoF->anim_global_sync[anim_idx]=DefAnimInfo[i].global_sync;
	
		j=DefAnimInfo[i].no;
		if(j>0&&j<NUM_IMAGE_FILES)
			graphic_infoF->anim_index[j]=anim_idx;

		if(anim_idx<NUM_ANIMATIONS-1)
			anim_idx++;
		else
			bugd("Animation overflow at IMG ",j);			
	}

	// copy same animation
	i=0;
	while((src=copy_animation[i])!=-1)
	{
		int a_d=graphic_infoF->anim_index[src];
		i++;

		while(copy_animation[i]!=-1)
		{
			j=copy_animation[i];
			if(j>0&&j<NUM_IMAGE_FILES)
				graphic_infoF->anim_index[j]=a_d;//anim_idx;

			i++;
		}
		i++;
	}
	
};