#ifndef P_GFXINIT_H_INCLUDED
#define P_GFXINIT_H_INCLUDED

#include <PalmOS.h>

#include "RoNDi_res.h"

#include "main_.h"

#include "code_sections.h"

extern	Int32	ticks_wait;
extern	Int32	ideal_ticks;
extern	Int32	IdealTick;
extern	Int32	cur_tick;
extern	Int32	old_tick;

extern MemHandle      TileResH[BitMap_TotalNo];
extern unsigned long *TileResP0[BitMap_TotalNo];
extern unsigned long *TileResP[BitMap_TotalNo];  

#define MAXLEVSETS	10

struct LevSetInfo
{
	char num_levsets;
	char cur_levset;
	char name[MAXLEVSETS][32];
	LocalID	dbid[MAXLEVSETS];
	UInt16	card[MAXLEVSETS];
	char cur_level[MAXLEVSETS];
	char last_won_level[MAXLEVSETS];
	char levset_type[MAXLEVSETS];
};

/* values for level file type identifier */
#define LEVEL_FILE_TYPE_UNKNOWN		0
#define LEVEL_FILE_TYPE_RND		1
#define LEVEL_FILE_TYPE_BD		2
#define LEVEL_FILE_TYPE_EM		3
#define LEVEL_FILE_TYPE_SP		4
#define LEVEL_FILE_TYPE_DX		5
#define LEVEL_FILE_TYPE_SB		6
#define LEVEL_FILE_TYPE_DC		7

#define LEVEL_FILE_TYPE_RND_PACKED	(10 + LEVEL_FILE_TYPE_RND)
#define LEVEL_FILE_TYPE_EM_PACKED	(10 + LEVEL_FILE_TYPE_EM)

#define	CREATOR			'RoDi'
#define RND_TYPE		'Levl'
#define EM_TYPE			'LvEM'
#define TAPE_TYPE		'Tape'

extern struct LevSetInfo *LevelSets;

void ResetTicks(void) INIT_SECTION;

void ShowLevelName(void) INIT_SECTION;
void EndShowingLevelName(void) INIT_SECTION;

void LoadLevelSetsInfo(void) INIT_SECTION;
void SaveLevelSetsInfo(void) INIT_SECTION;
void FindAllLevelDBs(void) INIT_SECTION;

int PrepareResources(void) INIT_SECTION;
void ReleaseResources(void) INIT_SECTION;

int UseLatestEngine(void) INIT_SECTION;

int GetEM_LevelOffset(void) INIT_SECTION;

void SetDefaultGraphic(void) GFX_SECTION;

#endif
