#ifndef TOOLS_H_INCLUDED
#define TOOLS_H_INCLUDED

#include "main_.h"
#include "code_sections.h"

/* for SetDrawtoField */
#define DRAW_DIRECT		0
#define DRAW_BUFFERED		1
#define DRAW_BACKBUFFER		2

/* for DrawElementShifted */
#define NO_CUTTING		0
#define CUT_ABOVE		(1 << 0)
#define CUT_BELOW		(1 << 1)
#define CUT_LEFT		(1 << 2)
#define CUT_RIGHT		(1 << 3)

/* for masking functions */
#define NO_MASKING		0
#define USE_MASKING		1

/* for MoveDoor */
#define DOOR_OPEN_1		(1 << 0)
#define DOOR_OPEN_2		(1 << 1)
#define DOOR_CLOSE_1		(1 << 2)
#define DOOR_CLOSE_2		(1 << 3)
#define DOOR_OPEN_ALL		(DOOR_OPEN_1 | DOOR_OPEN_2)
#define DOOR_CLOSE_ALL		(DOOR_CLOSE_1 | DOOR_CLOSE_2)
#define DOOR_ACTION_1		(DOOR_OPEN_1 | DOOR_CLOSE_1)
#define DOOR_ACTION_2		(DOOR_OPEN_2 | DOOR_CLOSE_2)
#define DOOR_ACTION		(DOOR_ACTION_1 | DOOR_ACTION_2)
#define DOOR_COPY_BACK		(1 << 4)
#define DOOR_NO_DELAY		(1 << 5)
#define DOOR_GET_STATE		(1 << 6)
#define DOOR_SET_STATE		(1 << 7)

void SetDrawtoField(int);

void BackToFront();
void FadeToFront();
void ClearWindow();

void MarkTileDirty(int, int);
void SetBorderElement();

#define SetRandomAnimationValue(xy)	{gfx_anim_random_frame = GfxRandom[xy];}
//	gfx.anim_random_frame = GfxRandom[x][y];

char getGraphicAnimationFrame(short int, long);

void DrawGraphicAnimation(int, int, int);

void DrawLevelElementAnimation(int, int, int);
void DrawLevelGraphicAnimationIfNeeded(int, int, int);
void DrawLevelElementAnimationIfNeeded(int, int, int);

void DrawAllPlayers(void);
void DrawPlayerField(int, int);
void DrawPlayer(struct PlayerInfo *);

void DrawGraphic(int, int, int, int);

void DrawGraphicThruMask(int, int, int, int);

void DrawGraphicShifted(int, int, int, int, int, int, int, int);
#define DrawGraphicShiftedThruMask(x,y,dx,dy,graphic,frame,cut_mode)		\
				DrawGraphicShifted(x,y, dx,dy, graphic, frame, cut_mode, USE_MASKING)
 
void DrawScreenElementExt(int, int, int, int, int, int, int);

#define DrawLevelElementExt(x,y,dx,dy,element,cut_mode,mask_mode)		\
	{if (IN_LEV_FIELD(x, y) && IN_SCR_FIELD(SCREENX(x), SCREENY(y)))	\
		DrawScreenElementExt(SCREENX(x),SCREENY(y),dx,dy,element,cut_mode,mask_mode);}

#define DrawScreenElementShifted(x,y,dx,dy,element,cut_mode)			\
			DrawScreenElementExt(x,y,dx,dy,element,cut_mode,NO_MASKING)

#define DrawLevelElementThruMask(x,y,element)			\
			DrawLevelElementExt(x, y,0,0,element,NO_CUTTING,USE_MASKING)

#define DrawLevelFieldThruMask(x,y)			\
			DrawLevelElementExt(x,y,0,0,Feld[A2TO1(x,y)],NO_CUTTING,USE_MASKING)

void DrawLevelFieldCrumbledSand(int, int);

void DrawLevelFieldCrumbledSandNeighbours(int, int);
void DrawScreenElement(int, int, int);
void DrawLevelElement(int, int, int);

void DrawScreenField(int, int);
void DrawLevelField(int, int) LOGIC_SECTION;

void ShowEnvelope();

void DrawLevel(void);

unsigned int OpenDoor(unsigned int);
unsigned int CloseDoor(unsigned int);

unsigned int MoveDoor(unsigned int);

int el_act_dir2img(int, int, int);

#define el_act2img(element, action)		(element_infoF->def_graphic[element])
/* was int el_act2img(int element, int action)
{
  element = GFX_ELEMENT(element);

  return element_info[element].graphic[action];
} */
#define el_dir2img(element, direction)		(element_infoF->def_graphic[element])
/* was int el_dir2img(int element, int direction)
{
  element = GFX_ELEMENT(element);

  return el_act_dir2img(element, ACTION_DEFAULT, direction);
} */

#define el2img(element)		(element_infoF->def_graphic[element])
/*was int el2img(int element)
{
//	element = GFX_ELEMENT(element); no custom_images in palm!!!

	return element_infoF->def_graphic[element];//was graphic[ACTION_DEFAULT];

}*/

//PALM only!!!!!!
short int GetExplodingGfx(short int);
short int FindGfxValue(short int , char , char );
boolean ActionGraphicExist(short int, char);

#define InitGfxValue(xy)			\
			{}

/*Gfx[xy]=FindGfxValue(Feld[xy],GfxAction[xy],MovDir[xy]);*/
//maybe GfxDir

#define InitGfxValueAndFeld(xy, element)			\
			{Feld[xy]=element;						}

/*Gfx[xy]=FindGfxValue(element,GfxAction[xy],MovDir[xy]);*/
//maybe GfxDir

#define InitGfxValueAndGfxAction(xy, action)		\
			{GfxAction[xy]=action;					}

/*Gfx[xy]=FindGfxValue(Feld[xy],action,MovDir[xy]);*/
//maybe GfxDir

short int GetPlayerGfx(struct PlayerInfo *);

#endif
