#include "video.h"
#include "tools.h"

#define		BACK_BUF_WIDTH_IN_BYTES		MAX_BUF_YSIZE*TILEY/2

WinHandle      VisibleWindow;

BitmapType    *MyBMP = NULL;
WinHandle      MyWindow;
unsigned long *MyBMPPntr = NULL;

BitmapType    *infoBMP = NULL;
WinHandle      infoWindow;
unsigned long *infoBMPPntr = NULL;

long int 	frm_cnt=0;

int WinXSetGreyscale()
{
	UInt16 err_c;

	UInt32 depth_;
	depth_=4;
	if(WinScreenMode(winScreenModeSet,NULL,NULL,&depth_,NULL)!=0)
		return 1;

	VisibleWindow = WinGetDisplayWindow();

	MyBMP = BmpCreate (MAX_BUF_XSIZE*TILEX, MAX_BUF_YSIZE*TILEY, 4, NULL, &err_c);
	if(err_c!=errNone)
		return 1;

	MyWindow = WinCreateBitmapWindow (MyBMP,&err_c);
	if(err_c!=errNone)
		return 1;

	MyBMPPntr = BmpGetBits (MyBMP);

	infoBMP = BmpCreate(160,8,4,NULL,&err_c);
	if(err_c!=errNone)
		return 1;

	infoWindow = WinCreateBitmapWindow (infoBMP,&err_c);
	if(err_c!=errNone)
		return 1;

	infoBMPPntr = BmpGetBits (infoBMP);

	return 0;
}

void WinXSetMono() {
	if(MyBMP!=NULL) BmpDelete(MyBMP);
	WinDeleteWindow(MyWindow,false);
	if(infoBMP!=NULL) BmpDelete(infoBMP);
	WinDeleteWindow(infoWindow,false);
	WinScreenMode(winScreenModeSetToDefaults,NULL,NULL,NULL,NULL);
}

void DrawByteAny(unsigned long* s0, unsigned long* d0, 
			char width, char height, char cx, char dx)
{
	unsigned char* s;
	unsigned char* d;
	int i,j,width_in_bytes;
	s=(unsigned char*)s0;
	d=(unsigned char*)d0;
	width_in_bytes=width>>1;
	s+=cx>>1;
	d+=dx>>1;
	for(i=0;i<height;i++)
	{
		for(j=0;j<width_in_bytes;j++)
			*d++=*s++;
		s+=128-width_in_bytes;
		d+=BACK_BUF_WIDTH_IN_BYTES-width_in_bytes;
	}
}

void DrawTileLRword(unsigned short int* s0, 
							unsigned short int* d0, char offset)
{
	unsigned short int* s;
	unsigned short int* d;
	s=s0;
	d=d0;
	d+=offset;
	
			*d++=*s++; *d++=*s++; *d++=*s++; *d=*s;
			s+=61; d+=BACK_BUF_WIDTH_IN_BYTES/2-3;
			*d++=*s++; *d++=*s++; *d++=*s++; *d=*s;
			s+=61; d+=BACK_BUF_WIDTH_IN_BYTES/2-3;
			*d++=*s++; *d++=*s++; *d++=*s++; *d=*s;
			s+=61; d+=BACK_BUF_WIDTH_IN_BYTES/2-3;
			*d++=*s++; *d++=*s++; *d++=*s++; *d=*s;
			s+=61; d+=BACK_BUF_WIDTH_IN_BYTES/2-3;

			*d++=*s++; *d++=*s++; *d++=*s++; *d=*s;
			s+=61; d+=BACK_BUF_WIDTH_IN_BYTES/2-3;
			*d++=*s++; *d++=*s++; *d++=*s++; *d=*s;
			s+=61; d+=BACK_BUF_WIDTH_IN_BYTES/2-3;
			*d++=*s++; *d++=*s++; *d++=*s++; *d=*s;
			s+=61; d+=BACK_BUF_WIDTH_IN_BYTES/2-3;
			*d++=*s++; *d++=*s++; *d++=*s++; *d=*s;
			s+=61; d+=BACK_BUF_WIDTH_IN_BYTES/2-3;

			*d++=*s++; *d++=*s++; *d++=*s++; *d=*s;
			s+=61; d+=BACK_BUF_WIDTH_IN_BYTES/2-3;
			*d++=*s++; *d++=*s++; *d++=*s++; *d=*s;
			s+=61; d+=BACK_BUF_WIDTH_IN_BYTES/2-3;
			*d++=*s++; *d++=*s++; *d++=*s++; *d=*s;
			s+=61; d+=BACK_BUF_WIDTH_IN_BYTES/2-3;
			*d++=*s++; *d++=*s++; *d++=*s++; *d=*s;
			s+=61; d+=BACK_BUF_WIDTH_IN_BYTES/2-3;

			*d++=*s++; *d++=*s++; *d++=*s++; *d=*s;
			s+=61; d+=BACK_BUF_WIDTH_IN_BYTES/2-3;
			*d++=*s++; *d++=*s++; *d++=*s++; *d=*s;
			s+=61; d+=BACK_BUF_WIDTH_IN_BYTES/2-3;
			*d++=*s++; *d++=*s++; *d++=*s++; *d=*s;
			s+=61; d+=BACK_BUF_WIDTH_IN_BYTES/2-3;
			*d++=*s++; *d++=*s++; *d++=*s++; *d=*s;
}

void DrawTileLRbyte(unsigned char* s0, 
									unsigned char* d0, char offset)
{
	unsigned char* s;
	unsigned char* d;
	int i;
	s=s0;
	d=d0;
	d+=offset;

	for(i=0;i<16;i++)
	{
		*d++=*s++; *d++=*s++; *d++=*s++; *d++=*s++; *d++=*s++; *d++=*s++;
				*d++=*s++; *d=*s; s+=121; d+=BACK_BUF_WIDTH_IN_BYTES-7;
	}
}

void DrawTileLRhalfbyte(unsigned char* s0, 
									unsigned char* d0, char offset)
{
	unsigned char* s;
	unsigned char* d;
	register unsigned char bzik,bzik2;
	int i;
	s=s0;
	d=d0;
	d+=offset>>1;

	for(i=0;i<16;i++)
	{//offset&1=1 always, so dest will be 1 pixel later
		bzik=*s++;
		*d=((*d)&0xF0)|(bzik>>4);
		d++;
		
		bzik2=*s++;
		*d++=(bzik<<4)|(bzik2>>4);
		
		bzik=*s++;
		*d++=(bzik2<<4)|(bzik>>4);
		
		bzik2=*s++;
		*d++=(bzik<<4)|(bzik2>>4);
		
		bzik=*s++;
		*d++=(bzik2<<4)|(bzik>>4);
		
		bzik2=*s++;
		*d++=(bzik<<4)|(bzik2>>4);
		
		bzik=*s++;
		*d++=(bzik2<<4)|(bzik>>4);
		
		bzik2=*s;
		*d++=(bzik<<4)|(bzik2>>4);

		*d=(bzik2<<4)|((*d)&0xF);
		
		s+=121; d+=BACK_BUF_WIDTH_IN_BYTES-8;
	}
}

void DrawTileLR(unsigned long* s0, unsigned long* d0, char offset)
{
	if((offset&3)==0)
		DrawTileLRword((unsigned short int*)s0,(unsigned short int*)d0,offset>>2);
	else if((offset&1)==0)
		DrawTileLRbyte((unsigned char*)s0,(unsigned char*)d0, offset>>1);
	else
		DrawTileLRhalfbyte((unsigned char*)s0,(unsigned char*)d0, offset);
}

void DrawTileUD(unsigned long* s0, unsigned long* d0, char size)
{
	unsigned long* s;
	unsigned long* d;
	s=s0;
	d=d0;
//if(size<16)bugd("DrawTileUD hex",size);
	switch(size)
	{
		case 16: *d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
		case 15: *d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
		case 14: *d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
		case 13: *d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
		case 12: *d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
		case 11: *d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
		case 10: *d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
		case 9: *d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
		case 8: *d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
		case 7: *d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
		case 6: *d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
		case 5: *d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
		case 4: *d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
		case 3: *d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
		case 2: *d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
		case 1: *d++=*s++; *d=*s; break;
		default:
			bugd("DrawTileUD invalid size", size);
	}
}

void DrawTileSimple(unsigned long* s0, unsigned long* d0)
{
	unsigned long* s;
	unsigned long* d;
	s=s0;
	d=d0;

	*d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
	*d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
	*d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
	*d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
	
	*d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
	*d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
	*d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
	*d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;

	*d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
	*d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
	*d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
	*d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;

	*d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
	*d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
	*d++=*s++; *d=*s; s+=31; d+=BACK_BUF_WIDTH_IN_BYTES/4-1;
	*d++=*s++; *d=*s;
}

void DrawMaskedByte(unsigned long* s0, unsigned long* d0, 
			char width, char height, char cx, char dx)
{
	unsigned char* s;
	unsigned char* d;
	int i,j,width_in_bytes;
	s=(unsigned char*)s0;
	d=(unsigned char*)d0;
	width_in_bytes=width>>1;
	s+=cx>>1;
	d+=dx>>1;
	for(i=0;i<height;i++)
	{
		for(j=0;j<width_in_bytes;j++)
		{
			if((*s)==0xFF)//source is black - no dest copy
				s++,d++;
			else if((*s&0xF)==0xF)//copy left, right is black
				*d++=((*d)&0xF)|((*s++)&0xF0);
			else if((*s&0xF0)==0xF0)//copy right, left is black
				*d++=((*d)&0xF0)|((*s++)&0xF);
			else//copy left and right
				*d++=*s++;
		}
		s+=128-width_in_bytes;
		d+=BACK_BUF_WIDTH_IN_BYTES-width_in_bytes;
	}
//	if(dx!=0)bugd("he",0);
}

void RedrawMainScr(){
	RectangleType srcRect;
	srcRect.topLeft.x=0;
	srcRect.topLeft.y=8;
	srcRect.extent.x=160;
	srcRect.extent.y=160;
	WinCopyRectangle(MyWindow,VisibleWindow,&srcRect,0,8,winPaint);
}

void RedrawInfoScr(short int offset, short int size){
	RectangleType srcRect;
	srcRect.topLeft.x=offset;
	srcRect.topLeft.y=0;
	srcRect.extent.x=size;
	srcRect.extent.y=8;
	WinCopyRectangle(infoWindow,VisibleWindow,&srcRect,offset,0,winPaint);
}

void PlayGame()
{
	if(DS_TestRender)
	{
		char TmpStr[10];
		int o_tick;

		o_tick=TimGetTicks();
		for(DS_TestRender=50;DS_TestRender>0;DS_TestRender--)
			{PalmTileBackToMain(0,0,1,1);PalmTileBackToMain(1,0,1,1);
			PalmTileBackToMain(2,0,1,1);}
		o_tick=TimGetTicks()-o_tick;
		StrIToA(TmpStr,o_tick);
		FrmCustomAlert(alt_String1,
				"Render Test 3x 1x1 50 frames in .01 sec: ",TmpStr,NULL);

		o_tick=TimGetTicks();
		for(DS_TestRender=50;DS_TestRender>0;DS_TestRender--)
			{PalmTileBackToMain(0,0,1,1);PalmTileBackToMain(0,1,1,1);
			PalmTileBackToMain(0,2,1,1);PalmTileBackToMain(0,3,1,1);}
		o_tick=TimGetTicks()-o_tick;
		StrIToA(TmpStr,o_tick);
		FrmCustomAlert(alt_String1,
				"Render Test 4y 1x1 50 frames in .01 sec: ",TmpStr,NULL);

		o_tick=TimGetTicks();
		for(DS_TestRender=50;DS_TestRender>0;DS_TestRender--)
			{PalmTileBackToMain(0,0,1,1);PalmTileBackToMain(1,1,1,1);
			PalmTileBackToMain(2,2,1,1);PalmTileBackToMain(3,3,1,1);}
		o_tick=TimGetTicks()-o_tick;
		StrIToA(TmpStr,o_tick);
		FrmCustomAlert(alt_String1,
				"Render Test 4diag 1x1 50 frames in .01 sec: ",TmpStr,NULL);

		o_tick=TimGetTicks();
		for(DS_TestRender=50;DS_TestRender>0;DS_TestRender--)
			{PalmTileBackToMain(0,0,10,1);}
		o_tick=TimGetTicks()-o_tick;
		StrIToA(TmpStr,o_tick);
		FrmCustomAlert(alt_String1,
				"Render Test 10x1 50 frames in .01 sec: ",TmpStr,NULL);

		o_tick=TimGetTicks();
		for(DS_TestRender=50;DS_TestRender>0;DS_TestRender--)
			{PalmTileBackToMain(0,0,1,10);}
		o_tick=TimGetTicks()-o_tick;
		StrIToA(TmpStr,o_tick);
		FrmCustomAlert(alt_String1,
				"Render Test 1x10 50 frames in .01 sec: ",TmpStr,NULL);
		DS_TestRender=0;
	}	
}

#define MAX_DIGITS	5

void PalmDrawInfoDigits(short int offset, short int value, 
													unsigned char digits_number)
{
	unsigned long* s;
	unsigned long* d;
	unsigned char i;
	unsigned short int cur;

	static short int arr_div[MAX_DIGITS]={10000,1000,100,10,1};

	if(digits_number>MAX_DIGITS)
		{bugd("Invalid InfoDigits",digits_number);return;}

	d=infoBMPPntr+offset;

	for(i=5-digits_number;i<5;i++)
	{
		cur=value/arr_div[i];
		value-=cur*arr_div[i];
		if(cur>9||cur<0)
			{bugd("UUPS! PalmDrawDigits!",cur);return;}

		s=TileResP[DigitsFont_id];
		s+=cur;//10 digits by 8pixels 4bit
		
		*d=*s; s+=10; d+=20;
		*d=*s; s+=10; d+=20;
		*d=*s; s+=10; d+=20;
		*d=*s; s+=10; d+=20;
		*d=*s; s+=10; d+=20;
		*d=*s; s+=10; d+=20;
		*d=*s; s+=10; d+=20;
		*d=*s;

		d-=7*20-1;
	}
}

void PalmDrawTime(short int value)
{
	PalmDrawInfoDigits(0,value,3);
	RedrawInfoScr(0,3*8);
}

void PalmDrawGemsLeft(short int value)
{
	PalmDrawInfoDigits(4,value,3);
	RedrawInfoScr(4*8,3*8);
}

void PalmDrawDynamiteLeft(short int value)
{
	if(value>99) value=99;
	PalmDrawInfoDigits(8,value,2);
	RedrawInfoScr(8*8,2*8);
}

void PalmDrawScore(short int value)
{
	PalmDrawInfoDigits(15,value,5);
	RedrawInfoScr(15*8,5*8);
}

void PalmDrawShifted(char x, char y, char width, char height, 
			char cx, char cy, char dx, char dy, short int graphic, char frame)
{
	unsigned long* s;
	unsigned long* d;
	unsigned int b,b2;
	byte be0;

//if(x!=stored_player_.jx&&y!=stored_player_.jy)bugd("PalmDrawShifted",x+y*256);
	if(graphic<0||graphic>=NUM_IMAGE_FILES)
	{
		bugd("HHHMMM, PalmDrawShifted bad graphic at x,y",x*256+y);
		graphic=IMG_DYNAMITE;
	}

	d=MyBMPPntr;

	d+=x+x+BACK_BUF_WIDTH_IN_BYTES/4*(TILEY*y+dy);

	s=TileResP[graphic_infoF->bmp_no[graphic]];
	be0=graphic_infoF->x_y[graphic]+frame;

	b2 = be0>>4;//16 tiles per 1 line
	b = be0&15;
	s += b+b+(b2<<9)+(cy<<5);
	
	if(width==16)
	{
		if(dx!=0)
		{//LEFT/RIGHT
			if(cx==0)
				DrawTileLR(s,d,dx);
		}
		else//UP/DOWN
			DrawTileUD(s,d,height);
	}
	else if(!(width&1)&&!(cx&1)&&!(dx&1))
		DrawByteAny(s,d,width,height,cx,dx);
}

void PalmDrawShiftedMasked(char x, char y, char width, char height, 
			char cx, char cy, char dx, char dy, short int graphic, char frame)
{
	unsigned long* s;
	unsigned long* d;
	unsigned int b,b2;
	byte be0;

	if(graphic<0||graphic>=NUM_IMAGE_FILES)
	{
		bugd("HHHMMM, PalmDrawShiftedMasked bad graphic at x,y",x*256+y);
		graphic=IMG_DYNAMITE;
	}

	d=MyBMPPntr;

	d+=x+x+BACK_BUF_WIDTH_IN_BYTES/4*(TILEY*y+dy);

	s=TileResP[graphic_infoF->bmp_no[graphic]];
	be0=graphic_infoF->x_y[graphic]+frame;

	b2 = be0>>4;//16 tiles per 1 line
	b = be0&15;
	s += b+b+(b2<<9)+(cy<<5);
	
	if(!(width&1)&&!(cx&1)&&!(dx&1))
		DrawMaskedByte(s,d,width,height,cx,dx);
}

void PalmEasyDrawThruMask(char x, char y, short int graphic, char frame)
{
	unsigned long* s;
	unsigned long* d;
	unsigned int b,b2;
	byte be0;

	if(graphic<0||graphic>=NUM_IMAGE_FILES)
	{
		bugd("HHHMMM, PalmEasyDrawThruMask bad graphic at x,y",x*256+y);
		graphic=IMG_DYNAMITE;
	}

	d=MyBMPPntr;

	d+=x+x+BACK_BUF_WIDTH_IN_BYTES/4*TILEY*y;

	s=TileResP[graphic_infoF->bmp_no[graphic]];
	be0=graphic_infoF->x_y[graphic]+frame;

	b2 = be0>>4;//16 tiles per 1 line
	b = be0&15;
	s += b+b+(b2<<9);

	DrawMaskedByte(s,d,16,16,0,0);
}

void PalmEasyDraw(char x, char y, short int graphic, char frame)
{
	unsigned long* s;
	unsigned long* d;
	unsigned int b,b2;
	byte be0;

	if(graphic<0||graphic>=NUM_IMAGE_FILES)
	{
		bugd("HHHMMM, PalmEasyDraw bad graphic at x,y",x*256+y);
		graphic=IMG_DYNAMITE;
	}
//if(x!=stored_player_.jx&&y!=stored_player_.jy)bugd("PalmEasyDraw",x+y*256);
	d=MyBMPPntr;

	d+=x+x+BACK_BUF_WIDTH_IN_BYTES/4*TILEY*y;

	s=TileResP[graphic_infoF->bmp_no[graphic]];
	be0=graphic_infoF->x_y[graphic]+frame;

	b2 = be0>>4;//16 tiles per 1 line
	b = be0&15;
	s += b+b+(b2<<9);

	DrawTileSimple(s,d);

}

void PalmTileBackToMain(char x, char y, char ntx, char nty)
{
	RectangleType srcRect;
	
	total50tiles+=(short)ntx*(short)nty;
	
	if(y==0)
	{
		srcRect.topLeft.x=x*TILEX;
		srcRect.topLeft.y=8;
		srcRect.extent.x=ntx*TILEX;
		srcRect.extent.y=nty*TILEY-8;
		WinCopyRectangle(MyWindow,VisibleWindow,&srcRect,x*TILEX,8,winPaint);
	}
	else
	{
		srcRect.topLeft.x=x*TILEX;
		srcRect.topLeft.y=y*TILEY;
		srcRect.extent.x=ntx*TILEX;
		srcRect.extent.y=nty*TILEY;
		WinCopyRectangle(MyWindow,VisibleWindow,&srcRect,x*TILEX,y*TILEY,winPaint);
	}
}
